module verifyequal_cog (
input bus_ack,
input ptr_w,
input [31:0] submod_cog_alu_r_out,
input submod_cog_alu_wr_out,
input submod_cog_ctra_pll_out,
input [31:0] pin_in,
input [31:0] reg_dira_q,
input [27:0] ptr_d,
input clk_pll,
input nres,
input posedge_clk_cog,
input [4:0] reg_m_q,
input bus_sel,
input submod_cog_alu_zo_out,
input negedge_nres,
input [31:0] reg_ix_q,
input [31:0] cnt,
input [32:0] submod_cog_ctrb_phs_out,
input reg_z_q,
input [31:0] submod_cog_vid_pin_out_out,
input [31:0] submod_cog_ctrb_pin_out_out,
input [31:0] submod_cog_ctra_pin_out_out,
input [8:0] reg_p_q,
input [31:0] reg_d_q,
input ena_bus,
input [7:0] pll_in,
input [27:0] reg_ptr_q,
input [32:0] submod_cog_ctra_phs_out,
input clk_cog,
input [31:0] reg_s_q,
input reg_match_q,
input reg_cancel_q,
input [31:0] submod_cog_ram_q_out,
input submod_cog_alu_co_out,
input reg_run_q,
input ena,
input submod_cog_ctrb_pll_out,
input submod_cog_vid_ack_out,
input reg_c_q,
input [31:0] reg_outa_q,
input [31:0] bus_q,
input negedge_ena,
input [31:0] reg_sy_q,
input bus_c
);
wire submod_cog_ram_clk_in_expected;
wire submod_cog_ram_clk_in_result;
wire submod_cog_ctra_ena_in_expected;
wire submod_cog_ctra_ena_in_result;
wire submod_cog_ctrb_ena_in_expected;
wire submod_cog_ctrb_ena_in_result;
wire submod_cog_ram_ena_in_expected;
wire submod_cog_ram_ena_in_result;
wire submod_cog_alu_bus_c_in_expected;
wire submod_cog_alu_bus_c_in_result;
wire reg_z_d_expected;
wire reg_z_d_result;
wire submod_cog_vid_carrier_in_expected;
wire submod_cog_vid_carrier_in_result;
wire submod_cog_ctrb_clk_pll_in_expected;
wire submod_cog_ctrb_clk_pll_in_result;
wire submod_cog_ctrb_setfrq_in_expected;
wire submod_cog_ctrb_setfrq_in_result;
wire [31:0] submod_cog_alu_bus_q_in_expected;
wire [31:0] submod_cog_alu_bus_q_in_result;
wire submod_cog_vid_clk_vid_in_expected;
wire submod_cog_vid_clk_vid_in_result;
wire [31:0] reg_dira_d_expected;
wire [31:0] reg_dira_d_result;
wire submod_cog_ctra_setctr_in_expected;
wire submod_cog_ctra_setctr_in_result;
wire [31:0] reg_ix_d_expected;
wire [31:0] reg_ix_d_result;
wire pll_out_expected;
wire pll_out_result;
wire [4:0] reg_m_d_expected;
wire [31:0] reg_m_d_result;
wire [31:0] submod_cog_vid_color_in_expected;
wire [31:0] submod_cog_vid_color_in_result;
wire submod_cog_vid_setvid_in_expected;
wire submod_cog_vid_setvid_in_result;
wire [31:0] submod_cog_vid_pixel_in_expected;
wire [31:0] submod_cog_vid_pixel_in_result;
wire submod_cog_vid_clk_cog_in_expected;
wire submod_cog_vid_clk_cog_in_result;
wire submod_cog_ctra_clk_cog_in_expected;
wire submod_cog_ctra_clk_cog_in_result;
wire submod_cog_ctra_setphs_in_expected;
wire submod_cog_ctra_setphs_in_result;
wire submod_cog_ctrb_clk_cog_in_expected;
wire submod_cog_ctrb_clk_cog_in_result;
wire [31:0] submod_cog_ram_d_in_expected;
wire [31:0] submod_cog_ram_d_in_result;
wire [31:0] submod_cog_ctrb_pin_in_in_expected;
wire [31:0] submod_cog_ctrb_pin_in_in_result;
wire [8:0] submod_cog_alu_p_in_expected;
wire [31:0] submod_cog_alu_p_in_result;
wire [31:0] pin_out_expected;
wire [31:0] pin_out_result;
wire submod_cog_ctrb_setphs_in_expected;
wire submod_cog_ctrb_setphs_in_result;
wire [27:0] reg_ptr_d_expected;
wire [31:0] reg_ptr_d_result;
wire submod_cog_ram_w_in_expected;
wire submod_cog_ram_w_in_result;
wire [31:0] submod_cog_alu_s_in_expected;
wire [31:0] submod_cog_alu_s_in_result;
wire [8:0] reg_p_d_expected;
wire [31:0] reg_p_d_result;
wire [8:0] submod_cog_ram_a_in_expected;
wire [31:0] submod_cog_ram_a_in_result;
wire submod_cog_alu_ci_in_expected;
wire submod_cog_alu_ci_in_result;
wire [31:0] reg_d_d_expected;
wire [31:0] reg_d_d_result;
wire [31:0] submod_cog_ctra_data_in_expected;
wire [31:0] submod_cog_ctra_data_in_result;
wire submod_cog_ctrb_setctr_in_expected;
wire submod_cog_ctrb_setctr_in_result;
wire reg_match_d_expected;
wire reg_match_d_result;
wire submod_cog_ctra_setfrq_in_expected;
wire submod_cog_ctra_setfrq_in_result;
wire [7:0] submod_cog_vid_aural_in_expected;
wire [31:0] submod_cog_vid_aural_in_result;
wire [31:0] pin_dir_expected;
wire [31:0] pin_dir_result;
wire [5:0] submod_cog_alu_i_in_expected;
wire [31:0] submod_cog_alu_i_in_result;
wire submod_cog_ctra_clk_pll_in_expected;
wire submod_cog_ctra_clk_pll_in_result;
wire [31:0] reg_outa_d_expected;
wire [31:0] reg_outa_d_result;
wire reg_run_d_expected;
wire reg_run_d_result;
wire [31:0] submod_cog_vid_data_in_expected;
wire [31:0] submod_cog_vid_data_in_result;
wire [31:0] reg_s_d_expected;
wire [31:0] reg_s_d_result;
wire [31:0] submod_cog_ctra_pin_in_in_expected;
wire [31:0] submod_cog_ctra_pin_in_in_result;
wire submod_cog_alu_run_in_expected;
wire submod_cog_alu_run_in_result;
wire [31:0] reg_sy_d_expected;
wire [31:0] reg_sy_d_result;
wire reg_cancel_d_expected;
wire reg_cancel_d_result;
wire submod_cog_vid_ena_in_expected;
wire submod_cog_vid_ena_in_result;
wire bus_w_expected;
wire bus_w_result;
wire [31:0] submod_cog_ctrb_data_in_expected;
wire [31:0] submod_cog_ctrb_data_in_result;
wire bus_r_expected;
wire bus_r_result;
wire reg_c_d_expected;
wire reg_c_d_result;
wire submod_cog_vid_setscl_in_expected;
wire submod_cog_vid_setscl_in_result;
wire [1:0] bus_s_expected;
wire [31:0] bus_s_result;
wire [15:0] bus_a_expected;
wire [31:0] bus_a_result;
wire [31:0] submod_cog_alu_d_in_expected;
wire [31:0] submod_cog_alu_d_in_result;
wire bus_e_expected;
wire bus_e_result;
wire submod_cog_alu_zi_in_expected;
wire submod_cog_alu_zi_in_result;
wire [31:0] bus_d_expected;
wire [31:0] bus_d_result;
cog golden(
    .bus_ack (bus_ack),
    .submod_cog_ram_clk_in (submod_cog_ram_clk_in_expected),
    .submod_cog_ctra_ena_in (submod_cog_ctra_ena_in_expected),
    .submod_cog_ctrb_ena_in (submod_cog_ctrb_ena_in_expected),
    .ptr_w (ptr_w),
    .submod_cog_alu_r_out (submod_cog_alu_r_out),
    .submod_cog_ram_ena_in (submod_cog_ram_ena_in_expected),
    .submod_cog_alu_bus_c_in (submod_cog_alu_bus_c_in_expected),
    .reg_z_d (reg_z_d_expected),
    .submod_cog_vid_carrier_in (submod_cog_vid_carrier_in_expected),
    .submod_cog_alu_wr_out (submod_cog_alu_wr_out),
    .submod_cog_ctra_pll_out (submod_cog_ctra_pll_out),
    .submod_cog_ctrb_clk_pll_in (submod_cog_ctrb_clk_pll_in_expected),
    .pin_in (pin_in),
    .submod_cog_ctrb_setfrq_in (submod_cog_ctrb_setfrq_in_expected),
    .submod_cog_alu_bus_q_in (submod_cog_alu_bus_q_in_expected),
    .reg_dira_q (reg_dira_q),
    .ptr_d (ptr_d),
    .submod_cog_vid_clk_vid_in (submod_cog_vid_clk_vid_in_expected),
    .clk_pll (clk_pll),
    .reg_dira_d (reg_dira_d_expected),
    .nres (nres),
    .posedge_clk_cog (posedge_clk_cog),
    .submod_cog_ctra_setctr_in (submod_cog_ctra_setctr_in_expected),
    .reg_m_q (reg_m_q),
    .bus_sel (bus_sel),
    .reg_ix_d (reg_ix_d_expected),
    .submod_cog_alu_zo_out (submod_cog_alu_zo_out),
    .pll_out (pll_out_expected),
    .negedge_nres (negedge_nres),
    .reg_m_d (reg_m_d_expected),
    .submod_cog_vid_color_in (submod_cog_vid_color_in_expected),
    .submod_cog_vid_setvid_in (submod_cog_vid_setvid_in_expected),
    .submod_cog_vid_pixel_in (submod_cog_vid_pixel_in_expected),
    .reg_ix_q (reg_ix_q),
    .submod_cog_vid_clk_cog_in (submod_cog_vid_clk_cog_in_expected),
    .submod_cog_ctra_clk_cog_in (submod_cog_ctra_clk_cog_in_expected),
    .cnt (cnt),
    .submod_cog_ctrb_phs_out (submod_cog_ctrb_phs_out),
    .submod_cog_ctra_setphs_in (submod_cog_ctra_setphs_in_expected),
    .submod_cog_ctrb_clk_cog_in (submod_cog_ctrb_clk_cog_in_expected),
    .reg_z_q (reg_z_q),
    .submod_cog_ram_d_in (submod_cog_ram_d_in_expected),
    .submod_cog_vid_pin_out_out (submod_cog_vid_pin_out_out),
    .submod_cog_ctrb_pin_in_in (submod_cog_ctrb_pin_in_in_expected),
    .submod_cog_alu_p_in (submod_cog_alu_p_in_expected),
    .submod_cog_ctrb_pin_out_out (submod_cog_ctrb_pin_out_out),
    .submod_cog_ctra_pin_out_out (submod_cog_ctra_pin_out_out),
    .pin_out (pin_out_expected),
    .submod_cog_ctrb_setphs_in (submod_cog_ctrb_setphs_in_expected),
    .reg_ptr_d (reg_ptr_d_expected),
    .submod_cog_ram_w_in (submod_cog_ram_w_in_expected),
    .reg_p_q (reg_p_q),
    .submod_cog_alu_s_in (submod_cog_alu_s_in_expected),
    .reg_p_d (reg_p_d_expected),
    .submod_cog_ram_a_in (submod_cog_ram_a_in_expected),
    .reg_d_q (reg_d_q),
    .submod_cog_alu_ci_in (submod_cog_alu_ci_in_expected),
    .ena_bus (ena_bus),
    .pll_in (pll_in),
    .reg_ptr_q (reg_ptr_q),
    .reg_d_d (reg_d_d_expected),
    .submod_cog_ctra_data_in (submod_cog_ctra_data_in_expected),
    .submod_cog_ctrb_setctr_in (submod_cog_ctrb_setctr_in_expected),
    .submod_cog_ctra_phs_out (submod_cog_ctra_phs_out),
    .reg_match_d (reg_match_d_expected),
    .clk_cog (clk_cog),
    .submod_cog_ctra_setfrq_in (submod_cog_ctra_setfrq_in_expected),
    .submod_cog_vid_aural_in (submod_cog_vid_aural_in_expected),
    .reg_s_q (reg_s_q),
    .pin_dir (pin_dir_expected),
    .submod_cog_alu_i_in (submod_cog_alu_i_in_expected),
    .reg_match_q (reg_match_q),
    .submod_cog_ctra_clk_pll_in (submod_cog_ctra_clk_pll_in_expected),
    .reg_cancel_q (reg_cancel_q),
    .reg_outa_d (reg_outa_d_expected),
    .reg_run_d (reg_run_d_expected),
    .submod_cog_vid_data_in (submod_cog_vid_data_in_expected),
    .submod_cog_ram_q_out (submod_cog_ram_q_out),
    .submod_cog_alu_co_out (submod_cog_alu_co_out),
    .reg_s_d (reg_s_d_expected),
    .submod_cog_ctra_pin_in_in (submod_cog_ctra_pin_in_in_expected),
    .submod_cog_alu_run_in (submod_cog_alu_run_in_expected),
    .reg_sy_d (reg_sy_d_expected),
    .reg_run_q (reg_run_q),
    .ena (ena),
    .reg_cancel_d (reg_cancel_d_expected),
    .submod_cog_ctrb_pll_out (submod_cog_ctrb_pll_out),
    .submod_cog_vid_ack_out (submod_cog_vid_ack_out),
    .reg_c_q (reg_c_q),
    .submod_cog_vid_ena_in (submod_cog_vid_ena_in_expected),
    .reg_outa_q (reg_outa_q),
    .bus_w (bus_w_expected),
    .submod_cog_ctrb_data_in (submod_cog_ctrb_data_in_expected),
    .bus_r (bus_r_expected),
    .bus_q (bus_q),
    .reg_c_d (reg_c_d_expected),
    .negedge_ena (negedge_ena),
    .reg_sy_q (reg_sy_q),
    .submod_cog_vid_setscl_in (submod_cog_vid_setscl_in_expected),
    .bus_s (bus_s_expected),
    .bus_a (bus_a_expected),
    .submod_cog_alu_d_in (submod_cog_alu_d_in_expected),
    .bus_e (bus_e_expected),
    .submod_cog_alu_zi_in (submod_cog_alu_zi_in_expected),
    .bus_d (bus_d_expected),
    .bus_c (bus_c));
cloned_cog cloned(
    .bus_ack (bus_ack),
    .submod_cog_ram_clk_in (submod_cog_ram_clk_in_result),
    .submod_cog_ctra_ena_in (submod_cog_ctra_ena_in_result),
    .submod_cog_ctrb_ena_in (submod_cog_ctrb_ena_in_result),
    .ptr_w (ptr_w),
    .submod_cog_alu_r_out (submod_cog_alu_r_out),
    .submod_cog_ram_ena_in (submod_cog_ram_ena_in_result),
    .submod_cog_alu_bus_c_in (submod_cog_alu_bus_c_in_result),
    .reg_z_d (reg_z_d_result),
    .submod_cog_vid_carrier_in (submod_cog_vid_carrier_in_result),
    .submod_cog_alu_wr_out (submod_cog_alu_wr_out),
    .submod_cog_ctra_pll_out (submod_cog_ctra_pll_out),
    .submod_cog_ctrb_clk_pll_in (submod_cog_ctrb_clk_pll_in_result),
    .pin_in (pin_in),
    .submod_cog_ctrb_setfrq_in (submod_cog_ctrb_setfrq_in_result),
    .submod_cog_alu_bus_q_in (submod_cog_alu_bus_q_in_result),
    .reg_dira_q (reg_dira_q),
    .ptr_d (ptr_d),
    .submod_cog_vid_clk_vid_in (submod_cog_vid_clk_vid_in_result),
    .clk_pll (clk_pll),
    .reg_dira_d (reg_dira_d_result),
    .nres (nres),
    .posedge_clk_cog (posedge_clk_cog),
    .submod_cog_ctra_setctr_in (submod_cog_ctra_setctr_in_result),
    .reg_m_q (reg_m_q),
    .bus_sel (bus_sel),
    .reg_ix_d (reg_ix_d_result),
    .submod_cog_alu_zo_out (submod_cog_alu_zo_out),
    .pll_out (pll_out_result),
    .negedge_nres (negedge_nres),
    .reg_m_d (reg_m_d_result),
    .submod_cog_vid_color_in (submod_cog_vid_color_in_result),
    .submod_cog_vid_setvid_in (submod_cog_vid_setvid_in_result),
    .submod_cog_vid_pixel_in (submod_cog_vid_pixel_in_result),
    .reg_ix_q (reg_ix_q),
    .submod_cog_vid_clk_cog_in (submod_cog_vid_clk_cog_in_result),
    .submod_cog_ctra_clk_cog_in (submod_cog_ctra_clk_cog_in_result),
    .cnt (cnt),
    .submod_cog_ctrb_phs_out (submod_cog_ctrb_phs_out),
    .submod_cog_ctra_setphs_in (submod_cog_ctra_setphs_in_result),
    .submod_cog_ctrb_clk_cog_in (submod_cog_ctrb_clk_cog_in_result),
    .reg_z_q (reg_z_q),
    .submod_cog_ram_d_in (submod_cog_ram_d_in_result),
    .submod_cog_vid_pin_out_out (submod_cog_vid_pin_out_out),
    .submod_cog_ctrb_pin_in_in (submod_cog_ctrb_pin_in_in_result),
    .submod_cog_alu_p_in (submod_cog_alu_p_in_result),
    .submod_cog_ctrb_pin_out_out (submod_cog_ctrb_pin_out_out),
    .submod_cog_ctra_pin_out_out (submod_cog_ctra_pin_out_out),
    .pin_out (pin_out_result),
    .submod_cog_ctrb_setphs_in (submod_cog_ctrb_setphs_in_result),
    .reg_ptr_d (reg_ptr_d_result),
    .submod_cog_ram_w_in (submod_cog_ram_w_in_result),
    .reg_p_q (reg_p_q),
    .submod_cog_alu_s_in (submod_cog_alu_s_in_result),
    .reg_p_d (reg_p_d_result),
    .submod_cog_ram_a_in (submod_cog_ram_a_in_result),
    .reg_d_q (reg_d_q),
    .submod_cog_alu_ci_in (submod_cog_alu_ci_in_result),
    .ena_bus (ena_bus),
    .pll_in (pll_in),
    .reg_ptr_q (reg_ptr_q),
    .reg_d_d (reg_d_d_result),
    .submod_cog_ctra_data_in (submod_cog_ctra_data_in_result),
    .submod_cog_ctrb_setctr_in (submod_cog_ctrb_setctr_in_result),
    .submod_cog_ctra_phs_out (submod_cog_ctra_phs_out),
    .reg_match_d (reg_match_d_result),
    .clk_cog (clk_cog),
    .submod_cog_ctra_setfrq_in (submod_cog_ctra_setfrq_in_result),
    .submod_cog_vid_aural_in (submod_cog_vid_aural_in_result),
    .reg_s_q (reg_s_q),
    .pin_dir (pin_dir_result),
    .submod_cog_alu_i_in (submod_cog_alu_i_in_result),
    .reg_match_q (reg_match_q),
    .submod_cog_ctra_clk_pll_in (submod_cog_ctra_clk_pll_in_result),
    .reg_cancel_q (reg_cancel_q),
    .reg_outa_d (reg_outa_d_result),
    .reg_run_d (reg_run_d_result),
    .submod_cog_vid_data_in (submod_cog_vid_data_in_result),
    .submod_cog_ram_q_out (submod_cog_ram_q_out),
    .submod_cog_alu_co_out (submod_cog_alu_co_out),
    .reg_s_d (reg_s_d_result),
    .submod_cog_ctra_pin_in_in (submod_cog_ctra_pin_in_in_result),
    .submod_cog_alu_run_in (submod_cog_alu_run_in_result),
    .reg_sy_d (reg_sy_d_result),
    .reg_run_q (reg_run_q),
    .ena (ena),
    .reg_cancel_d (reg_cancel_d_result),
    .submod_cog_ctrb_pll_out (submod_cog_ctrb_pll_out),
    .submod_cog_vid_ack_out (submod_cog_vid_ack_out),
    .reg_c_q (reg_c_q),
    .submod_cog_vid_ena_in (submod_cog_vid_ena_in_result),
    .reg_outa_q (reg_outa_q),
    .bus_w (bus_w_result),
    .submod_cog_ctrb_data_in (submod_cog_ctrb_data_in_result),
    .bus_r (bus_r_result),
    .bus_q (bus_q),
    .reg_c_d (reg_c_d_result),
    .negedge_ena (negedge_ena),
    .reg_sy_q (reg_sy_q),
    .submod_cog_vid_setscl_in (submod_cog_vid_setscl_in_result),
    .bus_s (bus_s_result),
    .bus_a (bus_a_result),
    .submod_cog_alu_d_in (submod_cog_alu_d_in_result),
    .bus_e (bus_e_result),
    .submod_cog_alu_zi_in (submod_cog_alu_zi_in_result),
    .bus_d (bus_d_result),
    .bus_c (bus_c));
assert property(submod_cog_ram_clk_in_result == submod_cog_ram_clk_in_expected);
assert property(submod_cog_ctra_ena_in_result == submod_cog_ctra_ena_in_expected);
assert property(submod_cog_ctrb_ena_in_result == submod_cog_ctrb_ena_in_expected);
assert property(submod_cog_ram_ena_in_result == submod_cog_ram_ena_in_expected);
assert property(submod_cog_alu_bus_c_in_result == submod_cog_alu_bus_c_in_expected);
assert property(reg_z_d_result == reg_z_d_expected);
assert property(submod_cog_vid_carrier_in_result == submod_cog_vid_carrier_in_expected);
assert property(submod_cog_ctrb_clk_pll_in_result == submod_cog_ctrb_clk_pll_in_expected);
assert property(submod_cog_ctrb_setfrq_in_result == submod_cog_ctrb_setfrq_in_expected);
assert property(submod_cog_alu_bus_q_in_result == submod_cog_alu_bus_q_in_expected);
assert property(submod_cog_vid_clk_vid_in_result == submod_cog_vid_clk_vid_in_expected);
assert property(reg_dira_d_result == reg_dira_d_expected);
assert property(submod_cog_ctra_setctr_in_result == submod_cog_ctra_setctr_in_expected);
assert property(reg_ix_d_result == reg_ix_d_expected);
assert property(pll_out_result == pll_out_expected);
assert property(reg_m_d_result[4:0] == reg_m_d_expected);
assert property(reg_m_d_result[31:5] == 64'h0);
assert property(submod_cog_vid_color_in_result == submod_cog_vid_color_in_expected);
assert property(submod_cog_vid_setvid_in_result == submod_cog_vid_setvid_in_expected);
assert property(submod_cog_vid_pixel_in_result == submod_cog_vid_pixel_in_expected);
assert property(submod_cog_vid_clk_cog_in_result == submod_cog_vid_clk_cog_in_expected);
assert property(submod_cog_ctra_clk_cog_in_result == submod_cog_ctra_clk_cog_in_expected);
assert property(submod_cog_ctra_setphs_in_result == submod_cog_ctra_setphs_in_expected);
assert property(submod_cog_ctrb_clk_cog_in_result == submod_cog_ctrb_clk_cog_in_expected);
assert property(submod_cog_ram_d_in_result == submod_cog_ram_d_in_expected);
assert property(submod_cog_ctrb_pin_in_in_result == submod_cog_ctrb_pin_in_in_expected);
assert property(submod_cog_alu_p_in_result[8:0] == submod_cog_alu_p_in_expected);
assert property(submod_cog_alu_p_in_result[31:9] == 64'h0);
assert property(pin_out_result == pin_out_expected);
assert property(submod_cog_ctrb_setphs_in_result == submod_cog_ctrb_setphs_in_expected);
assert property(reg_ptr_d_result[27:0] == reg_ptr_d_expected);
assert property(reg_ptr_d_result[31:28] == 64'h0);
assert property(submod_cog_ram_w_in_result == submod_cog_ram_w_in_expected);
assert property(submod_cog_alu_s_in_result == submod_cog_alu_s_in_expected);
assert property(reg_p_d_result[8:0] == reg_p_d_expected);
assert property(reg_p_d_result[31:9] == 64'h0);
assert property(submod_cog_ram_a_in_result[8:0] == submod_cog_ram_a_in_expected);
assert property(submod_cog_ram_a_in_result[31:9] == 64'h0);
assert property(submod_cog_alu_ci_in_result == submod_cog_alu_ci_in_expected);
assert property(reg_d_d_result == reg_d_d_expected);
assert property(submod_cog_ctra_data_in_result == submod_cog_ctra_data_in_expected);
assert property(submod_cog_ctrb_setctr_in_result == submod_cog_ctrb_setctr_in_expected);
assert property(reg_match_d_result == reg_match_d_expected);
assert property(submod_cog_ctra_setfrq_in_result == submod_cog_ctra_setfrq_in_expected);
assert property(submod_cog_vid_aural_in_result[7:0] == submod_cog_vid_aural_in_expected);
assert property(submod_cog_vid_aural_in_result[31:8] == 64'h0);
assert property(pin_dir_result == pin_dir_expected);
assert property(submod_cog_alu_i_in_result[5:0] == submod_cog_alu_i_in_expected);
assert property(submod_cog_alu_i_in_result[31:6] == 64'h0);
assert property(submod_cog_ctra_clk_pll_in_result == submod_cog_ctra_clk_pll_in_expected);
assert property(reg_outa_d_result == reg_outa_d_expected);
assert property(reg_run_d_result == reg_run_d_expected);
assert property(submod_cog_vid_data_in_result == submod_cog_vid_data_in_expected);
assert property(reg_s_d_result == reg_s_d_expected);
assert property(submod_cog_ctra_pin_in_in_result == submod_cog_ctra_pin_in_in_expected);
assert property(submod_cog_alu_run_in_result == submod_cog_alu_run_in_expected);
assert property(reg_sy_d_result == reg_sy_d_expected);
assert property(reg_cancel_d_result == reg_cancel_d_expected);
assert property(submod_cog_vid_ena_in_result == submod_cog_vid_ena_in_expected);
assert property(bus_w_result == bus_w_expected);
assert property(submod_cog_ctrb_data_in_result == submod_cog_ctrb_data_in_expected);
assert property(bus_r_result == bus_r_expected);
assert property(reg_c_d_result == reg_c_d_expected);
assert property(submod_cog_vid_setscl_in_result == submod_cog_vid_setscl_in_expected);
assert property(bus_s_result[1:0] == bus_s_expected);
assert property(bus_s_result[31:2] == 64'h0);
assert property(bus_a_result[15:0] == bus_a_expected);
assert property(bus_a_result[31:16] == 64'h0);
assert property(submod_cog_alu_d_in_result == submod_cog_alu_d_in_expected);
assert property(bus_e_result == bus_e_expected);
assert property(submod_cog_alu_zi_in_result == submod_cog_alu_zi_in_expected);
assert property(bus_d_result == bus_d_expected);
endmodule

//-show submod_cog_ram_clk_in_result -show submod_cog_ram_clk_in_expected -show submod_cog_ctra_ena_in_result -show submod_cog_ctra_ena_in_expected -show submod_cog_ctrb_ena_in_result -show submod_cog_ctrb_ena_in_expected -show submod_cog_ram_ena_in_result -show submod_cog_ram_ena_in_expected -show submod_cog_alu_bus_c_in_result -show submod_cog_alu_bus_c_in_expected -show reg_z_d_result -show reg_z_d_expected -show submod_cog_vid_carrier_in_result -show submod_cog_vid_carrier_in_expected -show submod_cog_ctrb_clk_pll_in_result -show submod_cog_ctrb_clk_pll_in_expected -show submod_cog_ctrb_setfrq_in_result -show submod_cog_ctrb_setfrq_in_expected -show submod_cog_alu_bus_q_in_result -show submod_cog_alu_bus_q_in_expected -show submod_cog_vid_clk_vid_in_result -show submod_cog_vid_clk_vid_in_expected -show reg_dira_d_result -show reg_dira_d_expected -show submod_cog_ctra_setctr_in_result -show submod_cog_ctra_setctr_in_expected -show reg_ix_d_result -show reg_ix_d_expected -show pll_out_result -show pll_out_expected -show reg_m_d_result -show reg_m_d_expected -show submod_cog_vid_color_in_result -show submod_cog_vid_color_in_expected -show submod_cog_vid_setvid_in_result -show submod_cog_vid_setvid_in_expected -show submod_cog_vid_pixel_in_result -show submod_cog_vid_pixel_in_expected -show submod_cog_vid_clk_cog_in_result -show submod_cog_vid_clk_cog_in_expected -show submod_cog_ctra_clk_cog_in_result -show submod_cog_ctra_clk_cog_in_expected -show submod_cog_ctra_setphs_in_result -show submod_cog_ctra_setphs_in_expected -show submod_cog_ctrb_clk_cog_in_result -show submod_cog_ctrb_clk_cog_in_expected -show submod_cog_ram_d_in_result -show submod_cog_ram_d_in_expected -show submod_cog_ctrb_pin_in_in_result -show submod_cog_ctrb_pin_in_in_expected -show submod_cog_alu_p_in_result -show submod_cog_alu_p_in_expected -show pin_out_result -show pin_out_expected -show submod_cog_ctrb_setphs_in_result -show submod_cog_ctrb_setphs_in_expected -show reg_ptr_d_result -show reg_ptr_d_expected -show submod_cog_ram_w_in_result -show submod_cog_ram_w_in_expected -show submod_cog_alu_s_in_result -show submod_cog_alu_s_in_expected -show reg_p_d_result -show reg_p_d_expected -show submod_cog_ram_a_in_result -show submod_cog_ram_a_in_expected -show submod_cog_alu_ci_in_result -show submod_cog_alu_ci_in_expected -show reg_d_d_result -show reg_d_d_expected -show submod_cog_ctra_data_in_result -show submod_cog_ctra_data_in_expected -show submod_cog_ctrb_setctr_in_result -show submod_cog_ctrb_setctr_in_expected -show reg_match_d_result -show reg_match_d_expected -show submod_cog_ctra_setfrq_in_result -show submod_cog_ctra_setfrq_in_expected -show submod_cog_vid_aural_in_result -show submod_cog_vid_aural_in_expected -show pin_dir_result -show pin_dir_expected -show submod_cog_alu_i_in_result -show submod_cog_alu_i_in_expected -show submod_cog_ctra_clk_pll_in_result -show submod_cog_ctra_clk_pll_in_expected -show reg_outa_d_result -show reg_outa_d_expected -show reg_run_d_result -show reg_run_d_expected -show submod_cog_vid_data_in_result -show submod_cog_vid_data_in_expected -show reg_s_d_result -show reg_s_d_expected -show submod_cog_ctra_pin_in_in_result -show submod_cog_ctra_pin_in_in_expected -show submod_cog_alu_run_in_result -show submod_cog_alu_run_in_expected -show reg_sy_d_result -show reg_sy_d_expected -show reg_cancel_d_result -show reg_cancel_d_expected -show submod_cog_vid_ena_in_result -show submod_cog_vid_ena_in_expected -show bus_w_result -show bus_w_expected -show submod_cog_ctrb_data_in_result -show submod_cog_ctrb_data_in_expected -show bus_r_result -show bus_r_expected -show reg_c_d_result -show reg_c_d_expected -show submod_cog_vid_setscl_in_result -show submod_cog_vid_setscl_in_expected -show bus_s_result -show bus_s_expected -show bus_a_result -show bus_a_expected -show submod_cog_alu_d_in_result -show submod_cog_alu_d_in_expected -show bus_e_result -show bus_e_expected -show submod_cog_alu_zi_in_result -show submod_cog_alu_zi_in_expected -show bus_d_result -show bus_d_expected 

module cog (
input bus_ack,
output submod_cog_ram_clk_in,
output submod_cog_ctra_ena_in,
output submod_cog_ctrb_ena_in,
input ptr_w,
input [31:0] submod_cog_alu_r_out,
output submod_cog_ram_ena_in,
output submod_cog_alu_bus_c_in,
output reg reg_z_d,
output submod_cog_vid_carrier_in,
input submod_cog_alu_wr_out,
input submod_cog_ctra_pll_out,
output submod_cog_ctrb_clk_pll_in,
input [31:0] pin_in,
output submod_cog_ctrb_setfrq_in,
output [31:0] submod_cog_alu_bus_q_in,
input [31:0] reg_dira_q,
input [27:0] ptr_d,
output submod_cog_vid_clk_vid_in,
input clk_pll,
output reg [31:0] reg_dira_d,
input nres,
input posedge_clk_cog,
output submod_cog_ctra_setctr_in,
input [4:0] reg_m_q,
input bus_sel,
output reg [31:0] reg_ix_d,
input submod_cog_alu_zo_out,
output pll_out,
input negedge_nres,
output reg [4:0] reg_m_d,
output [31:0] submod_cog_vid_color_in,
output submod_cog_vid_setvid_in,
output [31:0] submod_cog_vid_pixel_in,
input [31:0] reg_ix_q,
output submod_cog_vid_clk_cog_in,
output submod_cog_ctra_clk_cog_in,
input [31:0] cnt,
input [32:0] submod_cog_ctrb_phs_out,
output submod_cog_ctra_setphs_in,
output submod_cog_ctrb_clk_cog_in,
input reg_z_q,
output [31:0] submod_cog_ram_d_in,
input [31:0] submod_cog_vid_pin_out_out,
output [31:0] submod_cog_ctrb_pin_in_in,
output [8:0] submod_cog_alu_p_in,
input [31:0] submod_cog_ctrb_pin_out_out,
input [31:0] submod_cog_ctra_pin_out_out,
output [31:0] pin_out,
output submod_cog_ctrb_setphs_in,
output reg [27:0] reg_ptr_d,
output submod_cog_ram_w_in,
input [8:0] reg_p_q,
output [31:0] submod_cog_alu_s_in,
output reg [8:0] reg_p_d,
output [8:0] submod_cog_ram_a_in,
input [31:0] reg_d_q,
output submod_cog_alu_ci_in,
input ena_bus,
input [7:0] pll_in,
input [27:0] reg_ptr_q,
output reg [31:0] reg_d_d,
output [31:0] submod_cog_ctra_data_in,
output submod_cog_ctrb_setctr_in,
input [32:0] submod_cog_ctra_phs_out,
output reg reg_match_d,
input clk_cog,
output submod_cog_ctra_setfrq_in,
output [7:0] submod_cog_vid_aural_in,
input [31:0] reg_s_q,
output [31:0] pin_dir,
output [5:0] submod_cog_alu_i_in,
input reg_match_q,
output submod_cog_ctra_clk_pll_in,
input reg_cancel_q,
output reg [31:0] reg_outa_d,
output reg reg_run_d,
output [31:0] submod_cog_vid_data_in,
input [31:0] submod_cog_ram_q_out,
input submod_cog_alu_co_out,
output reg [31:0] reg_s_d,
output [31:0] submod_cog_ctra_pin_in_in,
output submod_cog_alu_run_in,
output reg [31:0] reg_sy_d,
input reg_run_q,
input ena,
output reg reg_cancel_d,
input submod_cog_ctrb_pll_out,
input submod_cog_vid_ack_out,
input reg_c_q,
output submod_cog_vid_ena_in,
input [31:0] reg_outa_q,
output bus_w,
output [31:0] submod_cog_ctrb_data_in,
output bus_r,
input [31:0] bus_q,
output reg reg_c_d,
input negedge_ena,
input [31:0] reg_sy_q,
output submod_cog_vid_setscl_in,
output [1:0] bus_s,
output [15:0] bus_a,
output [31:0] submod_cog_alu_d_in,
output bus_e,
output submod_cog_alu_zi_in,
output [31:0] bus_d,
input bus_c
);
///////////////////////////////////
`include "constraints.v"


wire [1:0] jumpx;
wire [8:0] px;
wire cond;
wire ram_ena;
wire waitx;
wire jump;
wire [31:0] ctrb_pin_out;
wire waiti;
wire [3:0] condx;
wire alu_wr;
wire alu_zo;
wire plla;
wire pllb;
wire [31:0] ctra_pin_out;
wire [31:0] sx;
wire setfrqa;
wire setfrqb;
wire [31:0] i;
wire setouta;
wire setvid;
wire [32:0] phsa;
wire [32:0] phsb;
wire jump_cancel;
wire setscl;
wire [31:0] vid_pin_out;
wire setdira;
wire vidack;
wire alu_co;
wire setctrb;
wire [31:0] alu_r;
wire setctra;
wire dz;
wire wio;
wire ram_w;
wire [31:0] ram_q;
wire setphsb;
wire [8:0] ram_a;
wire setphsa;
assign wio = (reg_m_q[3] && (cond && (i[23] && (&i[17:13]))));
assign setouta = (wio && (i[12:9] == 4'b100));
assign setdira = (wio && (i[12:9] == 4'b110));
assign setctra = (wio && (i[12:9] == 4'b1000));
assign setctrb = (wio && (i[12:9] == 4'b1001));
assign setfrqa = (wio && (i[12:9] == 4'b1010));
assign setfrqb = (wio && (i[12:9] == 4'b1011));
assign setphsa = (wio && (i[12:9] == 4'b1100));
assign setphsb = (wio && (i[12:9] == 4'b1101));
assign setvid = (wio && (i[12:9] == 4'b1110));
assign setscl = (wio && (i[12:9] == 4'b1111));
assign ram_ena = (reg_m_q[0] || (reg_m_q[1] || (reg_m_q[2] || (reg_m_q[3] && (cond && i[23])))));
assign ram_w = (reg_m_q[3] && alu_wr);
assign ram_a = ((reg_m_q[2]) ? (px) : (((reg_m_q[0]) ? (i[8:0]) : (i[17:9]))));
assign pll_out = plla;
assign i = ((reg_run_q) ? (reg_ix_q) : ({14'h221, reg_p_q, 9'h0}));
assign sx = ((i[22]) ? ({23'h0, i[8:0]}) : ((((i[8:0] == 9'h1f0)) ? ({16'h0, reg_ptr_q[27:14], 2'b0}) : ((((i[8:0] == 9'h1f1)) ? (cnt) : ((((i[8:0] == 9'h1f2)) ? (pin_in) : ((((i[8:0] == 9'h1fc)) ? (phsa[31:0]) : ((((i[8:0] == 9'h1fd)) ? (phsb[31:0]) : (reg_sy_q))))))))))));
assign condx = i[21:18];
assign cond = (condx[{reg_c_q, reg_z_q}] && (!reg_cancel_q));
assign dz = (~|reg_d_q[31:1]);
assign jumpx = (((i[31:26] == 6'b10111)) ? ({1'b1, 1'b0}) : ((((i[31:26] == 6'b111001)) ? ({1'b1, (dz && reg_d_q[0])}) : ((((i[31:26] == 6'b111010)) ? ({1'b1, (dz && (!reg_d_q[0]))}) : ((((i[31:26] == 6'b111011)) ? ({1'b1, (!(dz && (!reg_d_q[0])))}) : ({1'b0, 1'b0}))))))));
assign jump = jumpx[1];
assign jump_cancel = jumpx[0];
assign px = (((cond && jump)) ? (sx[8:0]) : (reg_p_q));
assign bus_r = (((!bus_sel)) ? (1'b0) : (reg_run_q));
assign bus_e = (((!bus_sel)) ? (1'b0) : (((i[31:28] == 4'b0) && reg_m_q[4])));
assign bus_w = (((!bus_sel)) ? (1'b0) : ((!i[23])));
assign bus_s = (((!bus_sel)) ? (2'b0) : (i[27:26]));
assign bus_a = (((!bus_sel)) ? (16'h0) : (((reg_run_q) ? (reg_s_q[15:0]) : ({(reg_ptr_q[13:0] + {5'b0, reg_p_q}), reg_s_q[1:0]}))));
assign bus_d = (((!bus_sel)) ? (32'h0) : (reg_d_q));
assign waitx = (((i[31:28] == 4'b0)) ? ((!bus_ack)) : ((((i[31:27] == 5'b11110)) ? ((!reg_match_q)) : ((((i[31:26] == 6'b111110)) ? ((!reg_match_q)) : ((((i[31:26] == 6'b111111)) ? ((!vidack)) : (1'b0))))))));
assign waiti = (cond && waitx);
assign pin_out = ((reg_outa_q | (ctra_pin_out | (ctrb_pin_out | vid_pin_out))) & reg_dira_q);
assign pin_dir = reg_dira_q;
assign submod_cog_ram_a_in = ram_a;
assign ram_q = submod_cog_ram_q_out;
assign submod_cog_ram_clk_in = clk_cog;
assign submod_cog_ram_d_in = alu_r;
assign submod_cog_ram_w_in = ram_w;
assign submod_cog_ram_ena_in = ram_ena;
assign submod_cog_ctra_setfrq_in = setfrqa;
assign submod_cog_ctra_data_in = alu_r;
assign ctra_pin_out = submod_cog_ctra_pin_out_out;
assign plla = submod_cog_ctra_pll_out;
assign submod_cog_ctra_clk_pll_in = clk_pll;
assign submod_cog_ctra_pin_in_in = pin_in;
assign submod_cog_ctra_ena_in = ena;
assign submod_cog_ctra_clk_cog_in = clk_cog;
assign submod_cog_ctra_setphs_in = setphsa;
assign phsa = submod_cog_ctra_phs_out;
assign submod_cog_ctra_setctr_in = setctra;
assign submod_cog_ctrb_setfrq_in = setfrqb;
assign submod_cog_ctrb_data_in = alu_r;
assign ctrb_pin_out = submod_cog_ctrb_pin_out_out;
assign pllb = submod_cog_ctrb_pll_out;
assign submod_cog_ctrb_clk_pll_in = clk_pll;
assign submod_cog_ctrb_pin_in_in = pin_in;
assign submod_cog_ctrb_ena_in = ena;
assign submod_cog_ctrb_clk_cog_in = clk_cog;
assign submod_cog_ctrb_setphs_in = setphsb;
assign phsb = submod_cog_ctrb_phs_out;
assign submod_cog_ctrb_setctr_in = setctrb;
assign submod_cog_vid_data_in = alu_r;
assign submod_cog_vid_color_in = reg_d_q;
assign vid_pin_out = submod_cog_vid_pin_out_out;
assign vidack = submod_cog_vid_ack_out;
assign submod_cog_vid_clk_vid_in = plla;
assign submod_cog_vid_ena_in = ena;
assign submod_cog_vid_pixel_in = reg_s_q;
assign submod_cog_vid_aural_in = pll_in;
assign submod_cog_vid_setvid_in = setvid;
assign submod_cog_vid_carrier_in = pllb;
assign submod_cog_vid_setscl_in = setscl;
assign submod_cog_vid_clk_cog_in = clk_cog;
assign submod_cog_alu_run_in = reg_run_q;
assign alu_wr = submod_cog_alu_wr_out;
assign submod_cog_alu_d_in = reg_d_q;
assign submod_cog_alu_ci_in = reg_c_q;
assign submod_cog_alu_i_in = i[31:26];
assign submod_cog_alu_bus_q_in = bus_q;
assign alu_co = submod_cog_alu_co_out;
assign submod_cog_alu_zi_in = reg_z_q;
assign submod_cog_alu_p_in = reg_p_q;
assign alu_r = submod_cog_alu_r_out;
assign submod_cog_alu_s_in = reg_s_q;
assign alu_zo = submod_cog_alu_zo_out;
assign submod_cog_alu_bus_c_in = bus_c;
always @(*) begin
    reg_sy_d <= reg_sy_q;
    reg_dira_d <= reg_dira_q;
    reg_d_d <= reg_d_q;
    reg_p_d <= reg_p_q;
    reg_run_d <= reg_run_q;
    reg_ix_d <= reg_ix_q;
    reg_m_d <= reg_m_q;
    reg_c_d <= reg_c_q;
    reg_match_d <= reg_match_q;
    reg_cancel_d <= reg_cancel_q;
    reg_ptr_d <= reg_ptr_q;
    reg_s_d <= reg_s_q;
    reg_z_d <= reg_z_q;
    reg_outa_d <= reg_outa_q;
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_ptr_d <= 28'h3e00;
        end else begin
            if ((ena_bus && ptr_w)) begin
                reg_ptr_d <= ptr_d;
            end
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_m_d <= 5'b0;
        end else begin
            reg_m_d <= {((reg_m_q[2] || reg_m_q[4]) && waiti), ((reg_m_q[2] || reg_m_q[4]) && (!waiti)), reg_m_q[1], reg_m_q[0], ((!reg_m_q[4]) && ((!reg_m_q[2]) && ((!reg_m_q[1]) && (!reg_m_q[0]))))};
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_run_d <= 1'b0;
        end else begin
            if ((reg_m_q[3] && (&px))) begin
                reg_run_d <= 1'b1;
            end
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_p_d <= 1'b0;
        end else begin
            if ((reg_m_q[3] && (!(cond && jump_cancel)))) begin
                reg_p_d <= (px + 1'b1);
            end
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_c_d <= 1'b0;
        end else begin
            if ((reg_m_q[3] && (cond && i[24]))) begin
                reg_c_d <= alu_co;
            end
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_z_d <= 1'b0;
        end else begin
            if ((reg_m_q[3] && (cond && i[25]))) begin
                reg_z_d <= alu_zo;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (setouta) begin
            reg_outa_d <= alu_r;
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_dira_d <= 32'h0;
        end else begin
            if (setdira) begin
                reg_dira_d <= alu_r;
            end
        end
    end
    if (posedge_clk_cog) begin
        if (reg_m_q[3]) begin
            reg_ix_d <= ram_q;
        end
    end
    if (posedge_clk_cog) begin
        if (reg_m_q[1]) begin
            reg_sy_d <= ram_q;
        end
    end
    if (posedge_clk_cog) begin
        if (reg_m_q[2]) begin
            reg_s_d <= sx;
        end
    end
    if (posedge_clk_cog) begin
        if (reg_m_q[2]) begin
            reg_d_d <= ram_q;
        end
    end
    if ((posedge_clk_cog || negedge_ena)) begin
        if ((!ena)) begin
            reg_cancel_d <= 1'b0;
        end else begin
            if (reg_m_q[3]) begin
                reg_cancel_d <= ((cond && jump_cancel) || (&px));
            end
        end
    end
    if (posedge_clk_cog) begin
        reg_match_d <= (reg_m_q[4] && ((i[27:26] == 2'b1) ^ (((i[27]) ? (cnt) : ((pin_in & reg_s_q))) == reg_d_q)));
    end
end
endmodule

