#ifndef COGRAMANNOTATION_H
#define COGRAMANNOTATION_H

#include <QString>
#include <QVector>
#include <QStringList>

class CogRamAnnotation
{
public:
    struct Annotation {
        Annotation():noInstruction(false),forceSrcNumber(false),stepOver(false) {}
        QString label;
        QString comment;
        QStringList prependComments;
        bool noInstruction;
        bool forceSrcNumber;
        bool stepOver;
    };

    CogRamAnnotation();
    void clear();
    void loadFile(QString fileName);
    void saveFile(QString fileName);

    QVector<Annotation> annotations;
    QString name;
};

#endif // COGRAMANNOTATION_H
