#ifndef HUBVIEWER_H
#define HUBVIEWER_H

#include <QWidget>
#include "abstractpropeller.h"

namespace Ui {
class HubViewer;
}

class HubViewer : public QWidget
{
    Q_OBJECT

public:
    explicit HubViewer(QWidget *parent = nullptr);
    void setPropeller(AbstractPropeller *propeller);
    ~HubViewer();
public slots:
    void updateState();
private:
    enum {MemSize=16384};
    Ui::HubViewer *ui;
    AbstractPropeller *m_propeller;
    int m_lastMemory[MemSize];
};

#endif // HUBVIEWER_H
