;edx gibt den relativen pointer an
;rcx gibt die lookup tabelle an
;rückgabe in rax
lookupPointer:
        mov r8d,dword [rcx]   ;Anzahl der Einträge
        xor eax,eax
    .loop:
        cmp edx,dword [rcx+rax*8+4+0]
        jz .found
        add eax,1
        cmp eax,r8d
        jl .loop
        mov eax,0xFFFFFFFF
        ret
    .found:
        mov eax, dword[rcx+rax*8+4+4]
        ret

decodeCogStatePointer:
        mov edx,dword [rsi+cog_compound_statex]
        lea rcx,[rel cogStateDecoderTable]
        jmp lookupPointer

decodeHubStatePointer:
        mov edx,dword [rdi+hub_hub_state]
        lea rcx,[rel hubStateDecoderTable]
        jmp lookupPointer
