;Assembler Routinen, die auf Counter zugreifen, sollen für Counter A und B allgemein gehalten werden
;Hier werden deshalb allgemeine Register für CounterX definiert

%macro declare_ctrx_reg 3
    %if %3-%2 != 8
        %error "distance of counter registers != 8" %2 %3
    %endif
    %1 equ %2
%endmacro


declare_ctrx_reg        ctrreg_phase,           cog_reg_cog_ctra_phase,         cog_reg_cog_ctrb_phase          ;quint64
declare_ctrx_reg        ctrreg_pllcounter,      cog_reg_cog_ctra_pllcounter,    cog_reg_cog_ctrb_pllcounter     ;quint64
declare_ctrx_reg        ctrreg_frequency,       cog_reg_cog_ctra_frequency,     cog_reg_cog_ctrb_frequency      ;quint32
declare_ctrx_reg        ctrreg_ctrmode,         cog_reg_cog_ctra_ctrmode,       cog_reg_cog_ctrb_ctrmode        ;quint32
declare_ctrx_reg        ctrreg_ctrplldiv,       cog_reg_cog_ctra_ctrplldiv,     cog_reg_cog_ctrb_ctrplldiv      ;quint32
declare_ctrx_reg        ctrreg_ctrapin,         cog_reg_cog_ctra_ctrapin,       cog_reg_cog_ctrb_ctrapin        ;quint32
declare_ctrx_reg        ctrreg_ctrbpin,         cog_reg_cog_ctra_ctrbpin,       cog_reg_cog_ctrb_ctrbpin        ;quint32
declare_ctrx_reg        ctrreg_ctrapinmask,     cog_reg_cog_ctra_ctrapinmask,   cog_reg_cog_ctrb_ctrapinmask    ;quint32
declare_ctrx_reg        ctrreg_ctrbpinmask,     cog_reg_cog_ctra_ctrbpinmask,   cog_reg_cog_ctrb_ctrbpinmask    ;quint32
declare_ctrx_reg        ctrreg_delayed0,        cog_reg_cog_ctra_delayed0,      cog_reg_cog_ctrb_delayed0       ;bool
declare_ctrx_reg        ctrreg_delayed1,        cog_reg_cog_ctra_delayed1,      cog_reg_cog_ctrb_delayed1       ;bool
declare_ctrx_reg        ctrreg_pllsaved,        cog_plla_saved,                 cog_pllb_saved                  ;bool

CounterA equ 0
CounterB equ 8
