;Übliche Temporäre Register
%define A64 rax
%define A32 eax
%define A8 al

%define B64 r8
%define B32 r8d
%define B8 r8b

%define C64 r9
%define C32 r9d
%define C8 r9b

%define CNT64 rcx
%define CNT32 ecx
%define CNT8 cl

%define HUB             r10
%define HUBMEM          r10+HubRelMemoryOffset
%define HUBFUN          r10+HubRelDynamicAsmOffset
%define SCRATCHPAD      r10+HubRelScratchpadOffset
%define COG             r11
%define COGMEM          r11+CogRelMemoryOffset
%define COGFUN          r11+CogRelDynamicAsmOffset

%define SRC64 rsi
%define SRC32 esi

%define DST64 rdi
%define DST32 edi


%macro goto_if_true 2
    cmp %1,1
    je %2
%endmacro

%macro goto_if_false 2
    cmp %1,0
    je %2
%endmacro
