#ifndef REMAINING_PROPELLERASM_H
#define REMAINING_PROPELLERASM_H
#include <QDataStream>
#include "propeller-asm/propellerasmported.h"
#include "propeller-asm/asm-callstubs.gen.h"


namespace PropellerAsmInternals {

    struct PropellerAsmImplGen {
        static quint32 decrypt (const quint32 indata) {
            quint32 returnValue = 0x0;
            returnValue = 0x0;
            returnValue = ((((((((indata >> 0x3) & 0x1) << 0x1f) | (((indata >> 0x7) & 0x1) << 0x1e)) | ((((indata >> 0x15) & 0x1) << 0x1d) | (((indata >> 0xc) & 0x1) << 0x1c))) | (((((indata >> 0x6) & 0x1) << 0x1b) | (((indata >> 0x13) & 0x1) << 0x1a)) | ((((indata >> 0x4) & 0x1) << 0x19) | (((indata >> 0x11) & 0x1) << 0x18)))) | ((((((indata >> 0x14) & 0x1) << 0x17) | (((indata >> 0xf) & 0x1) << 0x16)) | ((((indata >> 0x8) & 0x1) << 0x15) | (((indata >> 0xb) & 0x1) << 0x14))) | (((((indata >> 0x0) & 0x1) << 0x13) | (((indata >> 0xe) & 0x1) << 0x12)) | ((((indata >> 0x1e) & 0x1) << 0x11) | (((indata >> 0x1) & 0x1) << 0x10))))) | (((((((indata >> 0x17) & 0x1) << 0xf) | (((indata >> 0x1f) & 0x1) << 0xe)) | ((((indata >> 0x10) & 0x1) << 0xd) | (((indata >> 0x5) & 0x1) << 0xc))) | (((((indata >> 0x9) & 0x1) << 0xb) | (((indata >> 0x12) & 0x1) << 0xa)) | ((((indata >> 0x19) & 0x1) << 0x9) | (((indata >> 0x2) & 0x1) << 0x8)))) | ((((((indata >> 0x1c) & 0x1) << 0x7) | (((indata >> 0x16) & 0x1) << 0x6)) | ((((indata >> 0xd) & 0x1) << 0x5) | (((indata >> 0x1b) & 0x1) << 0x4))) | (((((indata >> 0x1d) & 0x1) << 0x3) | (((indata >> 0x18) & 0x1) << 0x2)) | ((((indata >> 0x1a) & 0x1) << 0x1) | (((indata >> 0xa) & 0x1) << 0x0))))));
            return returnValue;
        }

        static void hubClkBusNena (rs_hub& reghub) {
            reghub.bus_q_reg = reghub.bus_q_reg_pre;
        }

        static void hubClkPostEvalEna (rs_hub& reghub,const quint32 bus_d,const quint32 bus_ashr2,const quint32 bus_state) {
            reghub.dc = bus_d;
            reghub.acshr2 = bus_ashr2;
            reghub.hub_state = bus_state;
        }
    };
}
#endif //REMAINING_PROPELLERASM_H
