#-------------------------------------------------
#
# Project created by QtCreator 2020-08-07T21:45:28
#
#-------------------------------------------------

QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = propellersim
TEMPLATE = app

# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

CONFIG += c++11

SOURCES += \
        main.cpp \
        mainwindow.cpp \
        cogviewer.cpp \
    pdisasm.cpp \
    i2cdevice.cpp \
    hwtrace.cpp \
    filetools.cpp \
    abstractpropeller.cpp \
    simulationmaster.cpp \
    cogramannotation.cpp \
    cogramannotationdialog.cpp \
    vgadecoder.cpp \
    ps2device.cpp \
    hivewidget.cpp \
    hubviewer.cpp \
    i2ceeprom.cpp \
    propellerwidget.cpp

HEADERS += \
        mainwindow.h \
        cogviewer.h \
    pdisasm.h \
    i2cdevice.h \
    hwtrace.h \
    filetools.h \
    cogalu.h \
    abstractpropeller.h \
    simulationmaster.h \
    cogramannotation.h \
    cogramannotationdialog.h \
    vgadecoder.h \
    ps2device.h \
    hivewidget.h \
    hubviewer.h \
    i2ceeprom.h \
    propellerwidget.h

FORMS += \
        mainwindow.ui \
        cogviewer.ui \
    cogramannotationdialog.ui \
    hivewidget.ui \
    hubviewer.ui


QMAKE_CXXFLAGS_RELEASE -= -O2

include(propeller-gencpp/propeller-gencpp.pri)
include(propeller-newcpp/propeller-newcpp.pri)
include(propeller-asm/propeller-asm.pri)
#include(propeller-verilator/propeller-verilator.pri)

#Verilator
#LIBS += ../../propellersim/propeller-verilator/verilog/obj_dir/Vdig__ALL.a
INCLUDEPATH += propeller-verilator/verilog/obj_dir
INCLUDEPATH += /usr/share/verilator/include
INCLUDEPATH += /usr/share/verilator/include/vltstd

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target
