module verifyequal_dig (
input [31:0] submod_cog_4_bus_d_out,
input submod_cog_0_bus_e_out,
input [1:0] submod_cog_2_bus_s_out,
input submod_cog_6_bus_r_out,
input submod_hub_bus_c_out,
input submod_cog_0_bus_w_out,
input [15:0] submod_cog_2_bus_a_out,
input submod_cog_2_pll_out_out,
input submod_cog_3_pll_out_out,
input submod_cog_4_pll_out_out,
input submod_cog_5_pll_out_out,
input submod_cog_6_pll_out_out,
input [31:0] submod_cog_3_bus_d_out,
input submod_cog_5_bus_r_out,
input submod_cog_7_pll_out_out,
input [15:0] submod_cog_1_bus_a_out,
input clk_pll,
input [1:0] submod_cog_1_bus_s_out,
input [31:0] submod_hub_bus_q_out,
input posedge_clk_cog,
input [15:0] submod_cog_0_bus_a_out,
input [27:0] submod_hub_ptr_d_out,
input [1:0] submod_cog_0_bus_s_out,
input submod_cog_4_bus_r_out,
input negedge_nres,
input [1:0] submod_cog_3_bus_s_out,
input [31:0] submod_cog_5_bus_d_out,
input submod_cog_7_bus_r_out,
input submod_cog_1_bus_e_out,
input [31:0] submod_cog_2_bus_d_out,
input [15:0] submod_cog_3_bus_a_out,
input submod_cog_1_bus_w_out,
input [15:0] submod_cog_5_bus_a_out,
input submod_cog_4_bus_w_out,
input [1:0] submod_cog_5_bus_s_out,
input [31:0] submod_cog_1_bus_d_out,
input submod_cog_4_bus_e_out,
input [31:0] submod_cog_0_bus_d_out,
input [31:0] submod_cog_7_bus_d_out,
input [1:0] submod_cog_4_bus_s_out,
input [31:0] submod_cog_6_bus_d_out,
input [15:0] submod_cog_4_bus_a_out,
input [7:0] submod_hub_ptr_w_out,
input submod_cog_5_bus_w_out,
input submod_cog_0_bus_r_out,
input submod_cog_1_pll_out_out,
input submod_cog_5_bus_e_out,
input [31:0] reg_cnt_q,
input submod_cog_7_bus_e_out,
input reg_ena_bus_q,
input [31:0] pin_in,
input [31:0] submod_cog_0_pin_out_out,
input submod_cog_7_bus_w_out,
input [31:0] submod_cog_1_pin_dir_out,
input [31:0] submod_cog_0_pin_dir_out,
input [31:0] submod_cog_3_pin_dir_out,
input submod_cog_6_bus_e_out,
input [31:0] submod_cog_2_pin_dir_out,
input [31:0] submod_cog_7_pin_dir_out,
input [31:0] submod_cog_5_pin_dir_out,
input [31:0] submod_cog_4_pin_dir_out,
input [31:0] submod_cog_6_pin_dir_out,
input submod_cog_6_bus_w_out,
input nres,
input submod_cog_1_bus_r_out,
input [31:0] submod_cog_2_pin_out_out,
input [15:0] submod_cog_6_bus_a_out,
input [31:0] submod_cog_1_pin_out_out,
input [31:0] submod_cog_5_pin_out_out,
input [7:0] submod_hub_bus_ack_out,
input [31:0] submod_cog_4_pin_out_out,
input [31:0] submod_cog_3_pin_out_out,
input [7:0] submod_hub_cfg_out,
input [31:0] submod_cog_6_pin_out_out,
input [1:0] submod_cog_6_bus_s_out,
input [31:0] submod_cog_7_pin_out_out,
input submod_cog_2_bus_r_out,
input submod_cog_3_bus_w_out,
input clk_cog,
input submod_cog_3_bus_e_out,
input [7:0] reg_bus_sel_q,
input [15:0] submod_cog_7_bus_a_out,
input submod_cog_2_bus_e_out,
input [1:0] submod_cog_7_bus_s_out,
input submod_cog_2_bus_w_out,
input [7:0] submod_hub_cog_ena_out,
input submod_cog_0_pll_out_out,
input submod_cog_3_bus_r_out
);
wire submod_cog_4_bus_ack_in_expected;
wire submod_cog_4_bus_ack_in_result;
wire [7:0] submod_cog_5_pll_in_in_expected;
wire [31:0] submod_cog_5_pll_in_in_result;
wire submod_cog_1_ptr_w_in_expected;
wire submod_cog_1_ptr_w_in_result;
wire [31:0] submod_cog_3_pin_in_in_expected;
wire [31:0] submod_cog_3_pin_in_in_result;
wire submod_cog_1_bus_c_in_expected;
wire submod_cog_1_bus_c_in_result;
wire submod_cog_2_clk_pll_in_expected;
wire submod_cog_2_clk_pll_in_result;
wire [27:0] submod_cog_7_ptr_d_in_expected;
wire [31:0] submod_cog_7_ptr_d_in_result;
wire submod_cog_3_bus_sel_in_expected;
wire submod_cog_3_bus_sel_in_result;
wire submod_cog_4_clk_cog_in_expected;
wire submod_cog_4_clk_cog_in_result;
wire submod_cog_4_nres_in_expected;
wire submod_cog_4_nres_in_result;
wire [31:0] submod_cog_4_pin_in_in_expected;
wire [31:0] submod_cog_4_pin_in_in_result;
wire [31:0] submod_cog_2_bus_q_in_expected;
wire [31:0] submod_cog_2_bus_q_in_result;
wire [1:0] submod_hub_bus_s_in_expected;
wire [31:0] submod_hub_bus_s_in_result;
wire [31:0] submod_cog_7_bus_q_in_expected;
wire [31:0] submod_cog_7_bus_q_in_result;
wire [31:0] submod_cog_5_pin_in_in_expected;
wire [31:0] submod_cog_5_pin_in_in_result;
wire submod_cog_3_ena_bus_in_expected;
wire submod_cog_3_ena_bus_in_result;
wire [7:0] submod_cog_7_pll_in_in_expected;
wire [31:0] submod_cog_7_pll_in_in_result;
wire submod_cog_5_clk_cog_in_expected;
wire submod_cog_5_clk_cog_in_result;
wire submod_cog_5_bus_ack_in_expected;
wire submod_cog_5_bus_ack_in_result;
wire submod_cog_1_nres_in_expected;
wire submod_cog_1_nres_in_result;
wire [7:0] submod_cog_4_pll_in_in_expected;
wire [31:0] submod_cog_4_pll_in_in_result;
wire [31:0] submod_cog_2_pin_in_in_expected;
wire [31:0] submod_cog_2_pin_in_in_result;
wire submod_cog_6_ptr_w_in_expected;
wire submod_cog_6_ptr_w_in_result;
wire submod_cog_3_ptr_w_in_expected;
wire submod_cog_3_ptr_w_in_result;
wire [31:0] submod_cog_1_cnt_in_expected;
wire [31:0] submod_cog_1_cnt_in_result;
wire [7:0] cfg_expected;
wire [31:0] cfg_result;
wire submod_cog_2_ena_bus_in_expected;
wire submod_cog_2_ena_bus_in_result;
wire [31:0] submod_cog_5_cnt_in_expected;
wire [31:0] submod_cog_5_cnt_in_result;
wire submod_cog_3_bus_ack_in_expected;
wire submod_cog_3_bus_ack_in_result;
wire [31:0] submod_cog_4_bus_q_in_expected;
wire [31:0] submod_cog_4_bus_q_in_result;
wire submod_cog_1_ena_bus_in_expected;
wire submod_cog_1_ena_bus_in_result;
wire submod_cog_7_ena_bus_in_expected;
wire submod_cog_7_ena_bus_in_result;
wire submod_cog_4_ptr_w_in_expected;
wire submod_cog_4_ptr_w_in_result;
wire submod_cog_4_bus_c_in_expected;
wire submod_cog_4_bus_c_in_result;
wire [31:0] submod_cog_0_pin_in_in_expected;
wire [31:0] submod_cog_0_pin_in_in_result;
wire [31:0] submod_cog_7_pin_in_in_expected;
wire [31:0] submod_cog_7_pin_in_in_result;
wire submod_cog_2_nres_in_expected;
wire submod_cog_2_nres_in_result;
wire submod_cog_1_clk_pll_in_expected;
wire submod_cog_1_clk_pll_in_result;
wire submod_cog_5_bus_c_in_expected;
wire submod_cog_5_bus_c_in_result;
wire [31:0] submod_hub_bus_d_in_expected;
wire [31:0] submod_hub_bus_d_in_result;
wire submod_cog_6_bus_ack_in_expected;
wire submod_cog_6_bus_ack_in_result;
wire [31:0] submod_cog_6_bus_q_in_expected;
wire [31:0] submod_cog_6_bus_q_in_result;
wire submod_cog_3_clk_cog_in_expected;
wire submod_cog_3_clk_cog_in_result;
wire [7:0] submod_cog_1_pll_in_in_expected;
wire [31:0] submod_cog_1_pll_in_in_result;
wire submod_cog_2_ena_in_expected;
wire submod_cog_2_ena_in_result;
wire submod_cog_0_ena_in_expected;
wire submod_cog_0_ena_in_result;
wire submod_cog_1_bus_sel_in_expected;
wire submod_cog_1_bus_sel_in_result;
wire submod_cog_3_clk_pll_in_expected;
wire submod_cog_3_clk_pll_in_result;
wire [31:0] submod_cog_1_pin_in_in_expected;
wire [31:0] submod_cog_1_pin_in_in_result;
wire [31:0] pin_dir_expected;
wire [31:0] pin_dir_result;
wire [7:0] submod_cog_0_pll_in_in_expected;
wire [31:0] submod_cog_0_pll_in_in_result;
wire submod_cog_0_ptr_w_in_expected;
wire submod_cog_0_ptr_w_in_result;
wire [27:0] submod_cog_2_ptr_d_in_expected;
wire [31:0] submod_cog_2_ptr_d_in_result;
wire [27:0] submod_cog_5_ptr_d_in_expected;
wire [31:0] submod_cog_5_ptr_d_in_result;
wire submod_cog_7_bus_sel_in_expected;
wire submod_cog_7_bus_sel_in_result;
wire [31:0] submod_cog_0_bus_q_in_expected;
wire [31:0] submod_cog_0_bus_q_in_result;
wire [7:0] submod_cog_6_pll_in_in_expected;
wire [31:0] submod_cog_6_pll_in_in_result;
wire [31:0] submod_cog_3_bus_q_in_expected;
wire [31:0] submod_cog_3_bus_q_in_result;
wire submod_hub_nres_in_expected;
wire submod_hub_nres_in_result;
wire [31:0] submod_cog_6_pin_in_in_expected;
wire [31:0] submod_cog_6_pin_in_in_result;
wire submod_cog_7_clk_pll_in_expected;
wire submod_cog_7_clk_pll_in_result;
wire [31:0] submod_cog_7_cnt_in_expected;
wire [31:0] submod_cog_7_cnt_in_result;
wire submod_cog_5_ena_in_expected;
wire submod_cog_5_ena_in_result;
wire submod_cog_7_ptr_w_in_expected;
wire submod_cog_7_ptr_w_in_result;
wire submod_cog_5_bus_sel_in_expected;
wire submod_cog_5_bus_sel_in_result;
wire submod_cog_7_nres_in_expected;
wire submod_cog_7_nres_in_result;
wire submod_hub_bus_e_in_expected;
wire submod_hub_bus_e_in_result;
wire submod_cog_1_bus_ack_in_expected;
wire submod_cog_1_bus_ack_in_result;
wire submod_cog_0_bus_sel_in_expected;
wire submod_cog_0_bus_sel_in_result;
wire [7:0] cog_led_expected;
wire [31:0] cog_led_result;
wire submod_cog_1_clk_cog_in_expected;
wire submod_cog_1_clk_cog_in_result;
wire submod_cog_7_clk_cog_in_expected;
wire submod_cog_7_clk_cog_in_result;
wire submod_cog_0_nres_in_expected;
wire submod_cog_0_nres_in_result;
wire [31:0] reg_cnt_d_expected;
wire [31:0] reg_cnt_d_result;
wire submod_cog_5_clk_pll_in_expected;
wire submod_cog_5_clk_pll_in_result;
wire submod_cog_5_ena_bus_in_expected;
wire submod_cog_5_ena_bus_in_result;
wire [31:0] submod_cog_0_cnt_in_expected;
wire [31:0] submod_cog_0_cnt_in_result;
wire [31:0] submod_cog_2_cnt_in_expected;
wire [31:0] submod_cog_2_cnt_in_result;
wire [31:0] submod_cog_4_cnt_in_expected;
wire [31:0] submod_cog_4_cnt_in_result;
wire [31:0] submod_cog_6_cnt_in_expected;
wire [31:0] submod_cog_6_cnt_in_result;
wire submod_hub_clk_cog_in_expected;
wire submod_hub_clk_cog_in_result;
wire reg_ena_bus_d_expected;
wire reg_ena_bus_d_result;
wire submod_cog_7_bus_ack_in_expected;
wire submod_cog_7_bus_ack_in_result;
wire submod_cog_0_ena_bus_in_expected;
wire submod_cog_0_ena_bus_in_result;
wire [31:0] submod_cog_1_bus_q_in_expected;
wire [31:0] submod_cog_1_bus_q_in_result;
wire submod_cog_0_clk_pll_in_expected;
wire submod_cog_0_clk_pll_in_result;
wire submod_cog_0_bus_c_in_expected;
wire submod_cog_0_bus_c_in_result;
wire submod_cog_6_clk_cog_in_expected;
wire submod_cog_6_clk_cog_in_result;
wire submod_cog_2_bus_c_in_expected;
wire submod_cog_2_bus_c_in_result;
wire submod_cog_7_ena_in_expected;
wire submod_cog_7_ena_in_result;
wire submod_cog_2_bus_ack_in_expected;
wire submod_cog_2_bus_ack_in_result;
wire submod_cog_5_nres_in_expected;
wire submod_cog_5_nres_in_result;
wire [27:0] submod_cog_6_ptr_d_in_expected;
wire [31:0] submod_cog_6_ptr_d_in_result;
wire submod_cog_3_ena_in_expected;
wire submod_cog_3_ena_in_result;
wire submod_cog_7_bus_c_in_expected;
wire submod_cog_7_bus_c_in_result;
wire [27:0] submod_cog_1_ptr_d_in_expected;
wire [31:0] submod_cog_1_ptr_d_in_result;
wire [31:0] pin_out_expected;
wire [31:0] pin_out_result;
wire [7:0] reg_bus_sel_d_expected;
wire [31:0] reg_bus_sel_d_result;
wire [27:0] submod_cog_4_ptr_d_in_expected;
wire [31:0] submod_cog_4_ptr_d_in_result;
wire [15:0] submod_hub_bus_a_in_expected;
wire [31:0] submod_hub_bus_a_in_result;
wire [31:0] submod_cog_5_bus_q_in_expected;
wire [31:0] submod_cog_5_bus_q_in_result;
wire [7:0] submod_cog_2_pll_in_in_expected;
wire [31:0] submod_cog_2_pll_in_in_result;
wire [7:0] submod_hub_bus_sel_in_expected;
wire [31:0] submod_hub_bus_sel_in_result;
wire submod_cog_5_ptr_w_in_expected;
wire submod_cog_5_ptr_w_in_result;
wire submod_cog_2_bus_sel_in_expected;
wire submod_cog_2_bus_sel_in_result;
wire submod_cog_6_ena_in_expected;
wire submod_cog_6_ena_in_result;
wire submod_cog_4_clk_pll_in_expected;
wire submod_cog_4_clk_pll_in_result;
wire [27:0] submod_cog_3_ptr_d_in_expected;
wire [31:0] submod_cog_3_ptr_d_in_result;
wire submod_cog_4_ena_bus_in_expected;
wire submod_cog_4_ena_bus_in_result;
wire submod_cog_4_ena_in_expected;
wire submod_cog_4_ena_in_result;
wire submod_cog_0_bus_ack_in_expected;
wire submod_cog_0_bus_ack_in_result;
wire submod_cog_6_nres_in_expected;
wire submod_cog_6_nres_in_result;
wire submod_cog_2_clk_cog_in_expected;
wire submod_cog_2_clk_cog_in_result;
wire submod_hub_bus_w_in_expected;
wire submod_hub_bus_w_in_result;
wire submod_hub_ena_bus_in_expected;
wire submod_hub_ena_bus_in_result;
wire submod_cog_6_clk_pll_in_expected;
wire submod_cog_6_clk_pll_in_result;
wire submod_cog_4_bus_sel_in_expected;
wire submod_cog_4_bus_sel_in_result;
wire [27:0] submod_cog_0_ptr_d_in_expected;
wire [31:0] submod_cog_0_ptr_d_in_result;
wire submod_cog_0_clk_cog_in_expected;
wire submod_cog_0_clk_cog_in_result;
wire submod_cog_6_ena_bus_in_expected;
wire submod_cog_6_ena_bus_in_result;
wire submod_hub_bus_r_in_expected;
wire submod_hub_bus_r_in_result;
wire submod_cog_3_bus_c_in_expected;
wire submod_cog_3_bus_c_in_result;
wire submod_cog_6_bus_c_in_expected;
wire submod_cog_6_bus_c_in_result;
wire submod_cog_2_ptr_w_in_expected;
wire submod_cog_2_ptr_w_in_result;
wire submod_cog_3_nres_in_expected;
wire submod_cog_3_nres_in_result;
wire [31:0] submod_cog_3_cnt_in_expected;
wire [31:0] submod_cog_3_cnt_in_result;
wire submod_cog_6_bus_sel_in_expected;
wire submod_cog_6_bus_sel_in_result;
wire submod_cog_1_ena_in_expected;
wire submod_cog_1_ena_in_result;
wire [7:0] submod_cog_3_pll_in_in_expected;
wire [31:0] submod_cog_3_pll_in_in_result;
dig golden(
    .submod_cog_4_bus_d_out (submod_cog_4_bus_d_out),
    .submod_cog_4_bus_ack_in (submod_cog_4_bus_ack_in_expected),
    .submod_cog_0_bus_e_out (submod_cog_0_bus_e_out),
    .submod_cog_2_bus_s_out (submod_cog_2_bus_s_out),
    .submod_cog_5_pll_in_in (submod_cog_5_pll_in_in_expected),
    .submod_cog_1_ptr_w_in (submod_cog_1_ptr_w_in_expected),
    .submod_cog_3_pin_in_in (submod_cog_3_pin_in_in_expected),
    .submod_cog_1_bus_c_in (submod_cog_1_bus_c_in_expected),
    .submod_cog_2_clk_pll_in (submod_cog_2_clk_pll_in_expected),
    .submod_cog_7_ptr_d_in (submod_cog_7_ptr_d_in_expected),
    .submod_cog_6_bus_r_out (submod_cog_6_bus_r_out),
    .submod_cog_3_bus_sel_in (submod_cog_3_bus_sel_in_expected),
    .submod_hub_bus_c_out (submod_hub_bus_c_out),
    .submod_cog_0_bus_w_out (submod_cog_0_bus_w_out),
    .submod_cog_2_bus_a_out (submod_cog_2_bus_a_out),
    .submod_cog_2_pll_out_out (submod_cog_2_pll_out_out),
    .submod_cog_3_pll_out_out (submod_cog_3_pll_out_out),
    .submod_cog_4_pll_out_out (submod_cog_4_pll_out_out),
    .submod_cog_4_clk_cog_in (submod_cog_4_clk_cog_in_expected),
    .submod_cog_5_pll_out_out (submod_cog_5_pll_out_out),
    .submod_cog_6_pll_out_out (submod_cog_6_pll_out_out),
    .submod_cog_3_bus_d_out (submod_cog_3_bus_d_out),
    .submod_cog_5_bus_r_out (submod_cog_5_bus_r_out),
    .submod_cog_7_pll_out_out (submod_cog_7_pll_out_out),
    .submod_cog_4_nres_in (submod_cog_4_nres_in_expected),
    .submod_cog_4_pin_in_in (submod_cog_4_pin_in_in_expected),
    .submod_cog_1_bus_a_out (submod_cog_1_bus_a_out),
    .submod_cog_2_bus_q_in (submod_cog_2_bus_q_in_expected),
    .clk_pll (clk_pll),
    .submod_cog_1_bus_s_out (submod_cog_1_bus_s_out),
    .submod_hub_bus_q_out (submod_hub_bus_q_out),
    .submod_hub_bus_s_in (submod_hub_bus_s_in_expected),
    .submod_cog_7_bus_q_in (submod_cog_7_bus_q_in_expected),
    .submod_cog_5_pin_in_in (submod_cog_5_pin_in_in_expected),
    .posedge_clk_cog (posedge_clk_cog),
    .submod_cog_3_ena_bus_in (submod_cog_3_ena_bus_in_expected),
    .submod_cog_0_bus_a_out (submod_cog_0_bus_a_out),
    .submod_cog_7_pll_in_in (submod_cog_7_pll_in_in_expected),
    .submod_cog_5_clk_cog_in (submod_cog_5_clk_cog_in_expected),
    .submod_cog_5_bus_ack_in (submod_cog_5_bus_ack_in_expected),
    .submod_cog_1_nres_in (submod_cog_1_nres_in_expected),
    .submod_cog_4_pll_in_in (submod_cog_4_pll_in_in_expected),
    .submod_hub_ptr_d_out (submod_hub_ptr_d_out),
    .submod_cog_0_bus_s_out (submod_cog_0_bus_s_out),
    .submod_cog_2_pin_in_in (submod_cog_2_pin_in_in_expected),
    .submod_cog_4_bus_r_out (submod_cog_4_bus_r_out),
    .submod_cog_6_ptr_w_in (submod_cog_6_ptr_w_in_expected),
    .submod_cog_3_ptr_w_in (submod_cog_3_ptr_w_in_expected),
    .negedge_nres (negedge_nres),
    .submod_cog_3_bus_s_out (submod_cog_3_bus_s_out),
    .submod_cog_1_cnt_in (submod_cog_1_cnt_in_expected),
    .submod_cog_5_bus_d_out (submod_cog_5_bus_d_out),
    .cfg (cfg_expected),
    .submod_cog_7_bus_r_out (submod_cog_7_bus_r_out),
    .submod_cog_2_ena_bus_in (submod_cog_2_ena_bus_in_expected),
    .submod_cog_5_cnt_in (submod_cog_5_cnt_in_expected),
    .submod_cog_1_bus_e_out (submod_cog_1_bus_e_out),
    .submod_cog_3_bus_ack_in (submod_cog_3_bus_ack_in_expected),
    .submod_cog_4_bus_q_in (submod_cog_4_bus_q_in_expected),
    .submod_cog_1_ena_bus_in (submod_cog_1_ena_bus_in_expected),
    .submod_cog_2_bus_d_out (submod_cog_2_bus_d_out),
    .submod_cog_3_bus_a_out (submod_cog_3_bus_a_out),
    .submod_cog_1_bus_w_out (submod_cog_1_bus_w_out),
    .submod_cog_7_ena_bus_in (submod_cog_7_ena_bus_in_expected),
    .submod_cog_5_bus_a_out (submod_cog_5_bus_a_out),
    .submod_cog_4_ptr_w_in (submod_cog_4_ptr_w_in_expected),
    .submod_cog_4_bus_c_in (submod_cog_4_bus_c_in_expected),
    .submod_cog_4_bus_w_out (submod_cog_4_bus_w_out),
    .submod_cog_0_pin_in_in (submod_cog_0_pin_in_in_expected),
    .submod_cog_5_bus_s_out (submod_cog_5_bus_s_out),
    .submod_cog_7_pin_in_in (submod_cog_7_pin_in_in_expected),
    .submod_cog_2_nres_in (submod_cog_2_nres_in_expected),
    .submod_cog_1_clk_pll_in (submod_cog_1_clk_pll_in_expected),
    .submod_cog_1_bus_d_out (submod_cog_1_bus_d_out),
    .submod_cog_4_bus_e_out (submod_cog_4_bus_e_out),
    .submod_cog_5_bus_c_in (submod_cog_5_bus_c_in_expected),
    .submod_hub_bus_d_in (submod_hub_bus_d_in_expected),
    .submod_cog_6_bus_ack_in (submod_cog_6_bus_ack_in_expected),
    .submod_cog_6_bus_q_in (submod_cog_6_bus_q_in_expected),
    .submod_cog_3_clk_cog_in (submod_cog_3_clk_cog_in_expected),
    .submod_cog_1_pll_in_in (submod_cog_1_pll_in_in_expected),
    .submod_cog_0_bus_d_out (submod_cog_0_bus_d_out),
    .submod_cog_2_ena_in (submod_cog_2_ena_in_expected),
    .submod_cog_0_ena_in (submod_cog_0_ena_in_expected),
    .submod_cog_1_bus_sel_in (submod_cog_1_bus_sel_in_expected),
    .submod_cog_3_clk_pll_in (submod_cog_3_clk_pll_in_expected),
    .submod_cog_7_bus_d_out (submod_cog_7_bus_d_out),
    .submod_cog_1_pin_in_in (submod_cog_1_pin_in_in_expected),
    .pin_dir (pin_dir_expected),
    .submod_cog_0_pll_in_in (submod_cog_0_pll_in_in_expected),
    .submod_cog_4_bus_s_out (submod_cog_4_bus_s_out),
    .submod_cog_0_ptr_w_in (submod_cog_0_ptr_w_in_expected),
    .submod_cog_6_bus_d_out (submod_cog_6_bus_d_out),
    .submod_cog_2_ptr_d_in (submod_cog_2_ptr_d_in_expected),
    .submod_cog_4_bus_a_out (submod_cog_4_bus_a_out),
    .submod_cog_5_ptr_d_in (submod_cog_5_ptr_d_in_expected),
    .submod_cog_7_bus_sel_in (submod_cog_7_bus_sel_in_expected),
    .submod_cog_0_bus_q_in (submod_cog_0_bus_q_in_expected),
    .submod_cog_6_pll_in_in (submod_cog_6_pll_in_in_expected),
    .submod_hub_ptr_w_out (submod_hub_ptr_w_out),
    .submod_cog_3_bus_q_in (submod_cog_3_bus_q_in_expected),
    .submod_hub_nres_in (submod_hub_nres_in_expected),
    .submod_cog_6_pin_in_in (submod_cog_6_pin_in_in_expected),
    .submod_cog_5_bus_w_out (submod_cog_5_bus_w_out),
    .submod_cog_0_bus_r_out (submod_cog_0_bus_r_out),
    .submod_cog_1_pll_out_out (submod_cog_1_pll_out_out),
    .submod_cog_5_bus_e_out (submod_cog_5_bus_e_out),
    .submod_cog_7_clk_pll_in (submod_cog_7_clk_pll_in_expected),
    .submod_cog_7_cnt_in (submod_cog_7_cnt_in_expected),
    .submod_cog_5_ena_in (submod_cog_5_ena_in_expected),
    .submod_cog_7_ptr_w_in (submod_cog_7_ptr_w_in_expected),
    .submod_cog_5_bus_sel_in (submod_cog_5_bus_sel_in_expected),
    .submod_cog_7_nres_in (submod_cog_7_nres_in_expected),
    .submod_hub_bus_e_in (submod_hub_bus_e_in_expected),
    .reg_cnt_q (reg_cnt_q),
    .submod_cog_1_bus_ack_in (submod_cog_1_bus_ack_in_expected),
    .submod_cog_0_bus_sel_in (submod_cog_0_bus_sel_in_expected),
    .submod_cog_7_bus_e_out (submod_cog_7_bus_e_out),
    .reg_ena_bus_q (reg_ena_bus_q),
    .cog_led (cog_led_expected),
    .submod_cog_1_clk_cog_in (submod_cog_1_clk_cog_in_expected),
    .submod_cog_7_clk_cog_in (submod_cog_7_clk_cog_in_expected),
    .submod_cog_0_nres_in (submod_cog_0_nres_in_expected),
    .pin_in (pin_in),
    .reg_cnt_d (reg_cnt_d_expected),
    .submod_cog_5_clk_pll_in (submod_cog_5_clk_pll_in_expected),
    .submod_cog_0_pin_out_out (submod_cog_0_pin_out_out),
    .submod_cog_7_bus_w_out (submod_cog_7_bus_w_out),
    .submod_cog_5_ena_bus_in (submod_cog_5_ena_bus_in_expected),
    .submod_cog_0_cnt_in (submod_cog_0_cnt_in_expected),
    .submod_cog_2_cnt_in (submod_cog_2_cnt_in_expected),
    .submod_cog_1_pin_dir_out (submod_cog_1_pin_dir_out),
    .submod_cog_0_pin_dir_out (submod_cog_0_pin_dir_out),
    .submod_cog_3_pin_dir_out (submod_cog_3_pin_dir_out),
    .submod_cog_4_cnt_in (submod_cog_4_cnt_in_expected),
    .submod_cog_6_cnt_in (submod_cog_6_cnt_in_expected),
    .submod_cog_6_bus_e_out (submod_cog_6_bus_e_out),
    .submod_cog_2_pin_dir_out (submod_cog_2_pin_dir_out),
    .submod_cog_7_pin_dir_out (submod_cog_7_pin_dir_out),
    .submod_hub_clk_cog_in (submod_hub_clk_cog_in_expected),
    .submod_cog_5_pin_dir_out (submod_cog_5_pin_dir_out),
    .submod_cog_4_pin_dir_out (submod_cog_4_pin_dir_out),
    .reg_ena_bus_d (reg_ena_bus_d_expected),
    .submod_cog_7_bus_ack_in (submod_cog_7_bus_ack_in_expected),
    .submod_cog_6_pin_dir_out (submod_cog_6_pin_dir_out),
    .submod_cog_0_ena_bus_in (submod_cog_0_ena_bus_in_expected),
    .submod_cog_6_bus_w_out (submod_cog_6_bus_w_out),
    .nres (nres),
    .submod_cog_1_bus_q_in (submod_cog_1_bus_q_in_expected),
    .submod_cog_0_clk_pll_in (submod_cog_0_clk_pll_in_expected),
    .submod_cog_0_bus_c_in (submod_cog_0_bus_c_in_expected),
    .submod_cog_1_bus_r_out (submod_cog_1_bus_r_out),
    .submod_cog_2_pin_out_out (submod_cog_2_pin_out_out),
    .submod_cog_6_clk_cog_in (submod_cog_6_clk_cog_in_expected),
    .submod_cog_6_bus_a_out (submod_cog_6_bus_a_out),
    .submod_cog_2_bus_c_in (submod_cog_2_bus_c_in_expected),
    .submod_cog_7_ena_in (submod_cog_7_ena_in_expected),
    .submod_cog_1_pin_out_out (submod_cog_1_pin_out_out),
    .submod_cog_5_pin_out_out (submod_cog_5_pin_out_out),
    .submod_hub_bus_ack_out (submod_hub_bus_ack_out),
    .submod_cog_2_bus_ack_in (submod_cog_2_bus_ack_in_expected),
    .submod_cog_5_nres_in (submod_cog_5_nres_in_expected),
    .submod_cog_4_pin_out_out (submod_cog_4_pin_out_out),
    .submod_cog_3_pin_out_out (submod_cog_3_pin_out_out),
    .submod_cog_6_ptr_d_in (submod_cog_6_ptr_d_in_expected),
    .submod_hub_cfg_out (submod_hub_cfg_out),
    .submod_cog_3_ena_in (submod_cog_3_ena_in_expected),
    .submod_cog_7_bus_c_in (submod_cog_7_bus_c_in_expected),
    .submod_cog_6_pin_out_out (submod_cog_6_pin_out_out),
    .submod_cog_1_ptr_d_in (submod_cog_1_ptr_d_in_expected),
    .submod_cog_6_bus_s_out (submod_cog_6_bus_s_out),
    .submod_cog_7_pin_out_out (submod_cog_7_pin_out_out),
    .pin_out (pin_out_expected),
    .reg_bus_sel_d (reg_bus_sel_d_expected),
    .submod_cog_4_ptr_d_in (submod_cog_4_ptr_d_in_expected),
    .submod_hub_bus_a_in (submod_hub_bus_a_in_expected),
    .submod_cog_5_bus_q_in (submod_cog_5_bus_q_in_expected),
    .submod_cog_2_bus_r_out (submod_cog_2_bus_r_out),
    .submod_cog_2_pll_in_in (submod_cog_2_pll_in_in_expected),
    .submod_hub_bus_sel_in (submod_hub_bus_sel_in_expected),
    .submod_cog_5_ptr_w_in (submod_cog_5_ptr_w_in_expected),
    .submod_cog_2_bus_sel_in (submod_cog_2_bus_sel_in_expected),
    .submod_cog_6_ena_in (submod_cog_6_ena_in_expected),
    .submod_cog_4_clk_pll_in (submod_cog_4_clk_pll_in_expected),
    .submod_cog_3_ptr_d_in (submod_cog_3_ptr_d_in_expected),
    .submod_cog_3_bus_w_out (submod_cog_3_bus_w_out),
    .submod_cog_4_ena_bus_in (submod_cog_4_ena_bus_in_expected),
    .submod_cog_4_ena_in (submod_cog_4_ena_in_expected),
    .submod_cog_0_bus_ack_in (submod_cog_0_bus_ack_in_expected),
    .submod_cog_6_nres_in (submod_cog_6_nres_in_expected),
    .clk_cog (clk_cog),
    .submod_cog_3_bus_e_out (submod_cog_3_bus_e_out),
    .submod_cog_2_clk_cog_in (submod_cog_2_clk_cog_in_expected),
    .submod_hub_bus_w_in (submod_hub_bus_w_in_expected),
    .reg_bus_sel_q (reg_bus_sel_q),
    .submod_hub_ena_bus_in (submod_hub_ena_bus_in_expected),
    .submod_cog_7_bus_a_out (submod_cog_7_bus_a_out),
    .submod_cog_2_bus_e_out (submod_cog_2_bus_e_out),
    .submod_cog_6_clk_pll_in (submod_cog_6_clk_pll_in_expected),
    .submod_cog_4_bus_sel_in (submod_cog_4_bus_sel_in_expected),
    .submod_cog_0_ptr_d_in (submod_cog_0_ptr_d_in_expected),
    .submod_cog_0_clk_cog_in (submod_cog_0_clk_cog_in_expected),
    .submod_cog_6_ena_bus_in (submod_cog_6_ena_bus_in_expected),
    .submod_cog_7_bus_s_out (submod_cog_7_bus_s_out),
    .submod_cog_2_bus_w_out (submod_cog_2_bus_w_out),
    .submod_hub_bus_r_in (submod_hub_bus_r_in_expected),
    .submod_cog_3_bus_c_in (submod_cog_3_bus_c_in_expected),
    .submod_cog_6_bus_c_in (submod_cog_6_bus_c_in_expected),
    .submod_hub_cog_ena_out (submod_hub_cog_ena_out),
    .submod_cog_2_ptr_w_in (submod_cog_2_ptr_w_in_expected),
    .submod_cog_3_nres_in (submod_cog_3_nres_in_expected),
    .submod_cog_3_cnt_in (submod_cog_3_cnt_in_expected),
    .submod_cog_6_bus_sel_in (submod_cog_6_bus_sel_in_expected),
    .submod_cog_0_pll_out_out (submod_cog_0_pll_out_out),
    .submod_cog_1_ena_in (submod_cog_1_ena_in_expected),
    .submod_cog_3_pll_in_in (submod_cog_3_pll_in_in_expected),
    .submod_cog_3_bus_r_out (submod_cog_3_bus_r_out));
cloned_dig cloned(
    .submod_cog_4_bus_d_out (submod_cog_4_bus_d_out),
    .submod_cog_4_bus_ack_in (submod_cog_4_bus_ack_in_result),
    .submod_cog_0_bus_e_out (submod_cog_0_bus_e_out),
    .submod_cog_2_bus_s_out (submod_cog_2_bus_s_out),
    .submod_cog_5_pll_in_in (submod_cog_5_pll_in_in_result),
    .submod_cog_1_ptr_w_in (submod_cog_1_ptr_w_in_result),
    .submod_cog_3_pin_in_in (submod_cog_3_pin_in_in_result),
    .submod_cog_1_bus_c_in (submod_cog_1_bus_c_in_result),
    .submod_cog_2_clk_pll_in (submod_cog_2_clk_pll_in_result),
    .submod_cog_7_ptr_d_in (submod_cog_7_ptr_d_in_result),
    .submod_cog_6_bus_r_out (submod_cog_6_bus_r_out),
    .submod_cog_3_bus_sel_in (submod_cog_3_bus_sel_in_result),
    .submod_hub_bus_c_out (submod_hub_bus_c_out),
    .submod_cog_0_bus_w_out (submod_cog_0_bus_w_out),
    .submod_cog_2_bus_a_out (submod_cog_2_bus_a_out),
    .submod_cog_2_pll_out_out (submod_cog_2_pll_out_out),
    .submod_cog_3_pll_out_out (submod_cog_3_pll_out_out),
    .submod_cog_4_pll_out_out (submod_cog_4_pll_out_out),
    .submod_cog_4_clk_cog_in (submod_cog_4_clk_cog_in_result),
    .submod_cog_5_pll_out_out (submod_cog_5_pll_out_out),
    .submod_cog_6_pll_out_out (submod_cog_6_pll_out_out),
    .submod_cog_3_bus_d_out (submod_cog_3_bus_d_out),
    .submod_cog_5_bus_r_out (submod_cog_5_bus_r_out),
    .submod_cog_7_pll_out_out (submod_cog_7_pll_out_out),
    .submod_cog_4_nres_in (submod_cog_4_nres_in_result),
    .submod_cog_4_pin_in_in (submod_cog_4_pin_in_in_result),
    .submod_cog_1_bus_a_out (submod_cog_1_bus_a_out),
    .submod_cog_2_bus_q_in (submod_cog_2_bus_q_in_result),
    .clk_pll (clk_pll),
    .submod_cog_1_bus_s_out (submod_cog_1_bus_s_out),
    .submod_hub_bus_q_out (submod_hub_bus_q_out),
    .submod_hub_bus_s_in (submod_hub_bus_s_in_result),
    .submod_cog_7_bus_q_in (submod_cog_7_bus_q_in_result),
    .submod_cog_5_pin_in_in (submod_cog_5_pin_in_in_result),
    .posedge_clk_cog (posedge_clk_cog),
    .submod_cog_3_ena_bus_in (submod_cog_3_ena_bus_in_result),
    .submod_cog_0_bus_a_out (submod_cog_0_bus_a_out),
    .submod_cog_7_pll_in_in (submod_cog_7_pll_in_in_result),
    .submod_cog_5_clk_cog_in (submod_cog_5_clk_cog_in_result),
    .submod_cog_5_bus_ack_in (submod_cog_5_bus_ack_in_result),
    .submod_cog_1_nres_in (submod_cog_1_nres_in_result),
    .submod_cog_4_pll_in_in (submod_cog_4_pll_in_in_result),
    .submod_hub_ptr_d_out (submod_hub_ptr_d_out),
    .submod_cog_0_bus_s_out (submod_cog_0_bus_s_out),
    .submod_cog_2_pin_in_in (submod_cog_2_pin_in_in_result),
    .submod_cog_4_bus_r_out (submod_cog_4_bus_r_out),
    .submod_cog_6_ptr_w_in (submod_cog_6_ptr_w_in_result),
    .submod_cog_3_ptr_w_in (submod_cog_3_ptr_w_in_result),
    .negedge_nres (negedge_nres),
    .submod_cog_3_bus_s_out (submod_cog_3_bus_s_out),
    .submod_cog_1_cnt_in (submod_cog_1_cnt_in_result),
    .submod_cog_5_bus_d_out (submod_cog_5_bus_d_out),
    .cfg (cfg_result),
    .submod_cog_7_bus_r_out (submod_cog_7_bus_r_out),
    .submod_cog_2_ena_bus_in (submod_cog_2_ena_bus_in_result),
    .submod_cog_5_cnt_in (submod_cog_5_cnt_in_result),
    .submod_cog_1_bus_e_out (submod_cog_1_bus_e_out),
    .submod_cog_3_bus_ack_in (submod_cog_3_bus_ack_in_result),
    .submod_cog_4_bus_q_in (submod_cog_4_bus_q_in_result),
    .submod_cog_1_ena_bus_in (submod_cog_1_ena_bus_in_result),
    .submod_cog_2_bus_d_out (submod_cog_2_bus_d_out),
    .submod_cog_3_bus_a_out (submod_cog_3_bus_a_out),
    .submod_cog_1_bus_w_out (submod_cog_1_bus_w_out),
    .submod_cog_7_ena_bus_in (submod_cog_7_ena_bus_in_result),
    .submod_cog_5_bus_a_out (submod_cog_5_bus_a_out),
    .submod_cog_4_ptr_w_in (submod_cog_4_ptr_w_in_result),
    .submod_cog_4_bus_c_in (submod_cog_4_bus_c_in_result),
    .submod_cog_4_bus_w_out (submod_cog_4_bus_w_out),
    .submod_cog_0_pin_in_in (submod_cog_0_pin_in_in_result),
    .submod_cog_5_bus_s_out (submod_cog_5_bus_s_out),
    .submod_cog_7_pin_in_in (submod_cog_7_pin_in_in_result),
    .submod_cog_2_nres_in (submod_cog_2_nres_in_result),
    .submod_cog_1_clk_pll_in (submod_cog_1_clk_pll_in_result),
    .submod_cog_1_bus_d_out (submod_cog_1_bus_d_out),
    .submod_cog_4_bus_e_out (submod_cog_4_bus_e_out),
    .submod_cog_5_bus_c_in (submod_cog_5_bus_c_in_result),
    .submod_hub_bus_d_in (submod_hub_bus_d_in_result),
    .submod_cog_6_bus_ack_in (submod_cog_6_bus_ack_in_result),
    .submod_cog_6_bus_q_in (submod_cog_6_bus_q_in_result),
    .submod_cog_3_clk_cog_in (submod_cog_3_clk_cog_in_result),
    .submod_cog_1_pll_in_in (submod_cog_1_pll_in_in_result),
    .submod_cog_0_bus_d_out (submod_cog_0_bus_d_out),
    .submod_cog_2_ena_in (submod_cog_2_ena_in_result),
    .submod_cog_0_ena_in (submod_cog_0_ena_in_result),
    .submod_cog_1_bus_sel_in (submod_cog_1_bus_sel_in_result),
    .submod_cog_3_clk_pll_in (submod_cog_3_clk_pll_in_result),
    .submod_cog_7_bus_d_out (submod_cog_7_bus_d_out),
    .submod_cog_1_pin_in_in (submod_cog_1_pin_in_in_result),
    .pin_dir (pin_dir_result),
    .submod_cog_0_pll_in_in (submod_cog_0_pll_in_in_result),
    .submod_cog_4_bus_s_out (submod_cog_4_bus_s_out),
    .submod_cog_0_ptr_w_in (submod_cog_0_ptr_w_in_result),
    .submod_cog_6_bus_d_out (submod_cog_6_bus_d_out),
    .submod_cog_2_ptr_d_in (submod_cog_2_ptr_d_in_result),
    .submod_cog_4_bus_a_out (submod_cog_4_bus_a_out),
    .submod_cog_5_ptr_d_in (submod_cog_5_ptr_d_in_result),
    .submod_cog_7_bus_sel_in (submod_cog_7_bus_sel_in_result),
    .submod_cog_0_bus_q_in (submod_cog_0_bus_q_in_result),
    .submod_cog_6_pll_in_in (submod_cog_6_pll_in_in_result),
    .submod_hub_ptr_w_out (submod_hub_ptr_w_out),
    .submod_cog_3_bus_q_in (submod_cog_3_bus_q_in_result),
    .submod_hub_nres_in (submod_hub_nres_in_result),
    .submod_cog_6_pin_in_in (submod_cog_6_pin_in_in_result),
    .submod_cog_5_bus_w_out (submod_cog_5_bus_w_out),
    .submod_cog_0_bus_r_out (submod_cog_0_bus_r_out),
    .submod_cog_1_pll_out_out (submod_cog_1_pll_out_out),
    .submod_cog_5_bus_e_out (submod_cog_5_bus_e_out),
    .submod_cog_7_clk_pll_in (submod_cog_7_clk_pll_in_result),
    .submod_cog_7_cnt_in (submod_cog_7_cnt_in_result),
    .submod_cog_5_ena_in (submod_cog_5_ena_in_result),
    .submod_cog_7_ptr_w_in (submod_cog_7_ptr_w_in_result),
    .submod_cog_5_bus_sel_in (submod_cog_5_bus_sel_in_result),
    .submod_cog_7_nres_in (submod_cog_7_nres_in_result),
    .submod_hub_bus_e_in (submod_hub_bus_e_in_result),
    .reg_cnt_q (reg_cnt_q),
    .submod_cog_1_bus_ack_in (submod_cog_1_bus_ack_in_result),
    .submod_cog_0_bus_sel_in (submod_cog_0_bus_sel_in_result),
    .submod_cog_7_bus_e_out (submod_cog_7_bus_e_out),
    .reg_ena_bus_q (reg_ena_bus_q),
    .cog_led (cog_led_result),
    .submod_cog_1_clk_cog_in (submod_cog_1_clk_cog_in_result),
    .submod_cog_7_clk_cog_in (submod_cog_7_clk_cog_in_result),
    .submod_cog_0_nres_in (submod_cog_0_nres_in_result),
    .pin_in (pin_in),
    .reg_cnt_d (reg_cnt_d_result),
    .submod_cog_5_clk_pll_in (submod_cog_5_clk_pll_in_result),
    .submod_cog_0_pin_out_out (submod_cog_0_pin_out_out),
    .submod_cog_7_bus_w_out (submod_cog_7_bus_w_out),
    .submod_cog_5_ena_bus_in (submod_cog_5_ena_bus_in_result),
    .submod_cog_0_cnt_in (submod_cog_0_cnt_in_result),
    .submod_cog_2_cnt_in (submod_cog_2_cnt_in_result),
    .submod_cog_1_pin_dir_out (submod_cog_1_pin_dir_out),
    .submod_cog_0_pin_dir_out (submod_cog_0_pin_dir_out),
    .submod_cog_3_pin_dir_out (submod_cog_3_pin_dir_out),
    .submod_cog_4_cnt_in (submod_cog_4_cnt_in_result),
    .submod_cog_6_cnt_in (submod_cog_6_cnt_in_result),
    .submod_cog_6_bus_e_out (submod_cog_6_bus_e_out),
    .submod_cog_2_pin_dir_out (submod_cog_2_pin_dir_out),
    .submod_cog_7_pin_dir_out (submod_cog_7_pin_dir_out),
    .submod_hub_clk_cog_in (submod_hub_clk_cog_in_result),
    .submod_cog_5_pin_dir_out (submod_cog_5_pin_dir_out),
    .submod_cog_4_pin_dir_out (submod_cog_4_pin_dir_out),
    .reg_ena_bus_d (reg_ena_bus_d_result),
    .submod_cog_7_bus_ack_in (submod_cog_7_bus_ack_in_result),
    .submod_cog_6_pin_dir_out (submod_cog_6_pin_dir_out),
    .submod_cog_0_ena_bus_in (submod_cog_0_ena_bus_in_result),
    .submod_cog_6_bus_w_out (submod_cog_6_bus_w_out),
    .nres (nres),
    .submod_cog_1_bus_q_in (submod_cog_1_bus_q_in_result),
    .submod_cog_0_clk_pll_in (submod_cog_0_clk_pll_in_result),
    .submod_cog_0_bus_c_in (submod_cog_0_bus_c_in_result),
    .submod_cog_1_bus_r_out (submod_cog_1_bus_r_out),
    .submod_cog_2_pin_out_out (submod_cog_2_pin_out_out),
    .submod_cog_6_clk_cog_in (submod_cog_6_clk_cog_in_result),
    .submod_cog_6_bus_a_out (submod_cog_6_bus_a_out),
    .submod_cog_2_bus_c_in (submod_cog_2_bus_c_in_result),
    .submod_cog_7_ena_in (submod_cog_7_ena_in_result),
    .submod_cog_1_pin_out_out (submod_cog_1_pin_out_out),
    .submod_cog_5_pin_out_out (submod_cog_5_pin_out_out),
    .submod_hub_bus_ack_out (submod_hub_bus_ack_out),
    .submod_cog_2_bus_ack_in (submod_cog_2_bus_ack_in_result),
    .submod_cog_5_nres_in (submod_cog_5_nres_in_result),
    .submod_cog_4_pin_out_out (submod_cog_4_pin_out_out),
    .submod_cog_3_pin_out_out (submod_cog_3_pin_out_out),
    .submod_cog_6_ptr_d_in (submod_cog_6_ptr_d_in_result),
    .submod_hub_cfg_out (submod_hub_cfg_out),
    .submod_cog_3_ena_in (submod_cog_3_ena_in_result),
    .submod_cog_7_bus_c_in (submod_cog_7_bus_c_in_result),
    .submod_cog_6_pin_out_out (submod_cog_6_pin_out_out),
    .submod_cog_1_ptr_d_in (submod_cog_1_ptr_d_in_result),
    .submod_cog_6_bus_s_out (submod_cog_6_bus_s_out),
    .submod_cog_7_pin_out_out (submod_cog_7_pin_out_out),
    .pin_out (pin_out_result),
    .reg_bus_sel_d (reg_bus_sel_d_result),
    .submod_cog_4_ptr_d_in (submod_cog_4_ptr_d_in_result),
    .submod_hub_bus_a_in (submod_hub_bus_a_in_result),
    .submod_cog_5_bus_q_in (submod_cog_5_bus_q_in_result),
    .submod_cog_2_bus_r_out (submod_cog_2_bus_r_out),
    .submod_cog_2_pll_in_in (submod_cog_2_pll_in_in_result),
    .submod_hub_bus_sel_in (submod_hub_bus_sel_in_result),
    .submod_cog_5_ptr_w_in (submod_cog_5_ptr_w_in_result),
    .submod_cog_2_bus_sel_in (submod_cog_2_bus_sel_in_result),
    .submod_cog_6_ena_in (submod_cog_6_ena_in_result),
    .submod_cog_4_clk_pll_in (submod_cog_4_clk_pll_in_result),
    .submod_cog_3_ptr_d_in (submod_cog_3_ptr_d_in_result),
    .submod_cog_3_bus_w_out (submod_cog_3_bus_w_out),
    .submod_cog_4_ena_bus_in (submod_cog_4_ena_bus_in_result),
    .submod_cog_4_ena_in (submod_cog_4_ena_in_result),
    .submod_cog_0_bus_ack_in (submod_cog_0_bus_ack_in_result),
    .submod_cog_6_nres_in (submod_cog_6_nres_in_result),
    .clk_cog (clk_cog),
    .submod_cog_3_bus_e_out (submod_cog_3_bus_e_out),
    .submod_cog_2_clk_cog_in (submod_cog_2_clk_cog_in_result),
    .submod_hub_bus_w_in (submod_hub_bus_w_in_result),
    .reg_bus_sel_q (reg_bus_sel_q),
    .submod_hub_ena_bus_in (submod_hub_ena_bus_in_result),
    .submod_cog_7_bus_a_out (submod_cog_7_bus_a_out),
    .submod_cog_2_bus_e_out (submod_cog_2_bus_e_out),
    .submod_cog_6_clk_pll_in (submod_cog_6_clk_pll_in_result),
    .submod_cog_4_bus_sel_in (submod_cog_4_bus_sel_in_result),
    .submod_cog_0_ptr_d_in (submod_cog_0_ptr_d_in_result),
    .submod_cog_0_clk_cog_in (submod_cog_0_clk_cog_in_result),
    .submod_cog_6_ena_bus_in (submod_cog_6_ena_bus_in_result),
    .submod_cog_7_bus_s_out (submod_cog_7_bus_s_out),
    .submod_cog_2_bus_w_out (submod_cog_2_bus_w_out),
    .submod_hub_bus_r_in (submod_hub_bus_r_in_result),
    .submod_cog_3_bus_c_in (submod_cog_3_bus_c_in_result),
    .submod_cog_6_bus_c_in (submod_cog_6_bus_c_in_result),
    .submod_hub_cog_ena_out (submod_hub_cog_ena_out),
    .submod_cog_2_ptr_w_in (submod_cog_2_ptr_w_in_result),
    .submod_cog_3_nres_in (submod_cog_3_nres_in_result),
    .submod_cog_3_cnt_in (submod_cog_3_cnt_in_result),
    .submod_cog_6_bus_sel_in (submod_cog_6_bus_sel_in_result),
    .submod_cog_0_pll_out_out (submod_cog_0_pll_out_out),
    .submod_cog_1_ena_in (submod_cog_1_ena_in_result),
    .submod_cog_3_pll_in_in (submod_cog_3_pll_in_in_result),
    .submod_cog_3_bus_r_out (submod_cog_3_bus_r_out));
assert property(submod_cog_4_bus_ack_in_result == submod_cog_4_bus_ack_in_expected);
assert property(submod_cog_5_pll_in_in_result[7:0] == submod_cog_5_pll_in_in_expected);
assert property(submod_cog_5_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_1_ptr_w_in_result == submod_cog_1_ptr_w_in_expected);
assert property(submod_cog_3_pin_in_in_result == submod_cog_3_pin_in_in_expected);
assert property(submod_cog_1_bus_c_in_result == submod_cog_1_bus_c_in_expected);
assert property(submod_cog_2_clk_pll_in_result == submod_cog_2_clk_pll_in_expected);
assert property(submod_cog_7_ptr_d_in_result[27:0] == submod_cog_7_ptr_d_in_expected);
assert property(submod_cog_7_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_3_bus_sel_in_result == submod_cog_3_bus_sel_in_expected);
assert property(submod_cog_4_clk_cog_in_result == submod_cog_4_clk_cog_in_expected);
assert property(submod_cog_4_nres_in_result == submod_cog_4_nres_in_expected);
assert property(submod_cog_4_pin_in_in_result == submod_cog_4_pin_in_in_expected);
assert property(submod_cog_2_bus_q_in_result == submod_cog_2_bus_q_in_expected);
assert property(submod_hub_bus_s_in_result[1:0] == submod_hub_bus_s_in_expected);
assert property(submod_hub_bus_s_in_result[31:2] == 64'h0);
assert property(submod_cog_7_bus_q_in_result == submod_cog_7_bus_q_in_expected);
assert property(submod_cog_5_pin_in_in_result == submod_cog_5_pin_in_in_expected);
assert property(submod_cog_3_ena_bus_in_result == submod_cog_3_ena_bus_in_expected);
assert property(submod_cog_7_pll_in_in_result[7:0] == submod_cog_7_pll_in_in_expected);
assert property(submod_cog_7_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_5_clk_cog_in_result == submod_cog_5_clk_cog_in_expected);
assert property(submod_cog_5_bus_ack_in_result == submod_cog_5_bus_ack_in_expected);
assert property(submod_cog_1_nres_in_result == submod_cog_1_nres_in_expected);
assert property(submod_cog_4_pll_in_in_result[7:0] == submod_cog_4_pll_in_in_expected);
assert property(submod_cog_4_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_2_pin_in_in_result == submod_cog_2_pin_in_in_expected);
assert property(submod_cog_6_ptr_w_in_result == submod_cog_6_ptr_w_in_expected);
assert property(submod_cog_3_ptr_w_in_result == submod_cog_3_ptr_w_in_expected);
assert property(submod_cog_1_cnt_in_result == submod_cog_1_cnt_in_expected);
assert property(cfg_result[7:0] == cfg_expected);
assert property(cfg_result[31:8] == 64'h0);
assert property(submod_cog_2_ena_bus_in_result == submod_cog_2_ena_bus_in_expected);
assert property(submod_cog_5_cnt_in_result == submod_cog_5_cnt_in_expected);
assert property(submod_cog_3_bus_ack_in_result == submod_cog_3_bus_ack_in_expected);
assert property(submod_cog_4_bus_q_in_result == submod_cog_4_bus_q_in_expected);
assert property(submod_cog_1_ena_bus_in_result == submod_cog_1_ena_bus_in_expected);
assert property(submod_cog_7_ena_bus_in_result == submod_cog_7_ena_bus_in_expected);
assert property(submod_cog_4_ptr_w_in_result == submod_cog_4_ptr_w_in_expected);
assert property(submod_cog_4_bus_c_in_result == submod_cog_4_bus_c_in_expected);
assert property(submod_cog_0_pin_in_in_result == submod_cog_0_pin_in_in_expected);
assert property(submod_cog_7_pin_in_in_result == submod_cog_7_pin_in_in_expected);
assert property(submod_cog_2_nres_in_result == submod_cog_2_nres_in_expected);
assert property(submod_cog_1_clk_pll_in_result == submod_cog_1_clk_pll_in_expected);
assert property(submod_cog_5_bus_c_in_result == submod_cog_5_bus_c_in_expected);
assert property(submod_hub_bus_d_in_result == submod_hub_bus_d_in_expected);
assert property(submod_cog_6_bus_ack_in_result == submod_cog_6_bus_ack_in_expected);
assert property(submod_cog_6_bus_q_in_result == submod_cog_6_bus_q_in_expected);
assert property(submod_cog_3_clk_cog_in_result == submod_cog_3_clk_cog_in_expected);
assert property(submod_cog_1_pll_in_in_result[7:0] == submod_cog_1_pll_in_in_expected);
assert property(submod_cog_1_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_2_ena_in_result == submod_cog_2_ena_in_expected);
assert property(submod_cog_0_ena_in_result == submod_cog_0_ena_in_expected);
assert property(submod_cog_1_bus_sel_in_result == submod_cog_1_bus_sel_in_expected);
assert property(submod_cog_3_clk_pll_in_result == submod_cog_3_clk_pll_in_expected);
assert property(submod_cog_1_pin_in_in_result == submod_cog_1_pin_in_in_expected);
assert property(pin_dir_result == pin_dir_expected);
assert property(submod_cog_0_pll_in_in_result[7:0] == submod_cog_0_pll_in_in_expected);
assert property(submod_cog_0_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_0_ptr_w_in_result == submod_cog_0_ptr_w_in_expected);
assert property(submod_cog_2_ptr_d_in_result[27:0] == submod_cog_2_ptr_d_in_expected);
assert property(submod_cog_2_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_5_ptr_d_in_result[27:0] == submod_cog_5_ptr_d_in_expected);
assert property(submod_cog_5_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_7_bus_sel_in_result == submod_cog_7_bus_sel_in_expected);
assert property(submod_cog_0_bus_q_in_result == submod_cog_0_bus_q_in_expected);
assert property(submod_cog_6_pll_in_in_result[7:0] == submod_cog_6_pll_in_in_expected);
assert property(submod_cog_6_pll_in_in_result[31:8] == 64'h0);
assert property(submod_cog_3_bus_q_in_result == submod_cog_3_bus_q_in_expected);
assert property(submod_hub_nres_in_result == submod_hub_nres_in_expected);
assert property(submod_cog_6_pin_in_in_result == submod_cog_6_pin_in_in_expected);
assert property(submod_cog_7_clk_pll_in_result == submod_cog_7_clk_pll_in_expected);
assert property(submod_cog_7_cnt_in_result == submod_cog_7_cnt_in_expected);
assert property(submod_cog_5_ena_in_result == submod_cog_5_ena_in_expected);
assert property(submod_cog_7_ptr_w_in_result == submod_cog_7_ptr_w_in_expected);
assert property(submod_cog_5_bus_sel_in_result == submod_cog_5_bus_sel_in_expected);
assert property(submod_cog_7_nres_in_result == submod_cog_7_nres_in_expected);
assert property(submod_hub_bus_e_in_result == submod_hub_bus_e_in_expected);
assert property(submod_cog_1_bus_ack_in_result == submod_cog_1_bus_ack_in_expected);
assert property(submod_cog_0_bus_sel_in_result == submod_cog_0_bus_sel_in_expected);
assert property(cog_led_result[7:0] == cog_led_expected);
assert property(cog_led_result[31:8] == 64'h0);
assert property(submod_cog_1_clk_cog_in_result == submod_cog_1_clk_cog_in_expected);
assert property(submod_cog_7_clk_cog_in_result == submod_cog_7_clk_cog_in_expected);
assert property(submod_cog_0_nres_in_result == submod_cog_0_nres_in_expected);
assert property(reg_cnt_d_result == reg_cnt_d_expected);
assert property(submod_cog_5_clk_pll_in_result == submod_cog_5_clk_pll_in_expected);
assert property(submod_cog_5_ena_bus_in_result == submod_cog_5_ena_bus_in_expected);
assert property(submod_cog_0_cnt_in_result == submod_cog_0_cnt_in_expected);
assert property(submod_cog_2_cnt_in_result == submod_cog_2_cnt_in_expected);
assert property(submod_cog_4_cnt_in_result == submod_cog_4_cnt_in_expected);
assert property(submod_cog_6_cnt_in_result == submod_cog_6_cnt_in_expected);
assert property(submod_hub_clk_cog_in_result == submod_hub_clk_cog_in_expected);
assert property(reg_ena_bus_d_result == reg_ena_bus_d_expected);
assert property(submod_cog_7_bus_ack_in_result == submod_cog_7_bus_ack_in_expected);
assert property(submod_cog_0_ena_bus_in_result == submod_cog_0_ena_bus_in_expected);
assert property(submod_cog_1_bus_q_in_result == submod_cog_1_bus_q_in_expected);
assert property(submod_cog_0_clk_pll_in_result == submod_cog_0_clk_pll_in_expected);
assert property(submod_cog_0_bus_c_in_result == submod_cog_0_bus_c_in_expected);
assert property(submod_cog_6_clk_cog_in_result == submod_cog_6_clk_cog_in_expected);
assert property(submod_cog_2_bus_c_in_result == submod_cog_2_bus_c_in_expected);
assert property(submod_cog_7_ena_in_result == submod_cog_7_ena_in_expected);
assert property(submod_cog_2_bus_ack_in_result == submod_cog_2_bus_ack_in_expected);
assert property(submod_cog_5_nres_in_result == submod_cog_5_nres_in_expected);
assert property(submod_cog_6_ptr_d_in_result[27:0] == submod_cog_6_ptr_d_in_expected);
assert property(submod_cog_6_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_3_ena_in_result == submod_cog_3_ena_in_expected);
assert property(submod_cog_7_bus_c_in_result == submod_cog_7_bus_c_in_expected);
assert property(submod_cog_1_ptr_d_in_result[27:0] == submod_cog_1_ptr_d_in_expected);
assert property(submod_cog_1_ptr_d_in_result[31:28] == 64'h0);
assert property(pin_out_result == pin_out_expected);
assert property(reg_bus_sel_d_result[7:0] == reg_bus_sel_d_expected);
assert property(reg_bus_sel_d_result[31:8] == 64'h0);
assert property(submod_cog_4_ptr_d_in_result[27:0] == submod_cog_4_ptr_d_in_expected);
assert property(submod_cog_4_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_hub_bus_a_in_result[15:0] == submod_hub_bus_a_in_expected);
assert property(submod_hub_bus_a_in_result[31:16] == 64'h0);
assert property(submod_cog_5_bus_q_in_result == submod_cog_5_bus_q_in_expected);
assert property(submod_cog_2_pll_in_in_result[7:0] == submod_cog_2_pll_in_in_expected);
assert property(submod_cog_2_pll_in_in_result[31:8] == 64'h0);
assert property(submod_hub_bus_sel_in_result[7:0] == submod_hub_bus_sel_in_expected);
assert property(submod_hub_bus_sel_in_result[31:8] == 64'h0);
assert property(submod_cog_5_ptr_w_in_result == submod_cog_5_ptr_w_in_expected);
assert property(submod_cog_2_bus_sel_in_result == submod_cog_2_bus_sel_in_expected);
assert property(submod_cog_6_ena_in_result == submod_cog_6_ena_in_expected);
assert property(submod_cog_4_clk_pll_in_result == submod_cog_4_clk_pll_in_expected);
assert property(submod_cog_3_ptr_d_in_result[27:0] == submod_cog_3_ptr_d_in_expected);
assert property(submod_cog_3_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_4_ena_bus_in_result == submod_cog_4_ena_bus_in_expected);
assert property(submod_cog_4_ena_in_result == submod_cog_4_ena_in_expected);
assert property(submod_cog_0_bus_ack_in_result == submod_cog_0_bus_ack_in_expected);
assert property(submod_cog_6_nres_in_result == submod_cog_6_nres_in_expected);
assert property(submod_cog_2_clk_cog_in_result == submod_cog_2_clk_cog_in_expected);
assert property(submod_hub_bus_w_in_result == submod_hub_bus_w_in_expected);
assert property(submod_hub_ena_bus_in_result == submod_hub_ena_bus_in_expected);
assert property(submod_cog_6_clk_pll_in_result == submod_cog_6_clk_pll_in_expected);
assert property(submod_cog_4_bus_sel_in_result == submod_cog_4_bus_sel_in_expected);
assert property(submod_cog_0_ptr_d_in_result[27:0] == submod_cog_0_ptr_d_in_expected);
assert property(submod_cog_0_ptr_d_in_result[31:28] == 64'h0);
assert property(submod_cog_0_clk_cog_in_result == submod_cog_0_clk_cog_in_expected);
assert property(submod_cog_6_ena_bus_in_result == submod_cog_6_ena_bus_in_expected);
assert property(submod_hub_bus_r_in_result == submod_hub_bus_r_in_expected);
assert property(submod_cog_3_bus_c_in_result == submod_cog_3_bus_c_in_expected);
assert property(submod_cog_6_bus_c_in_result == submod_cog_6_bus_c_in_expected);
assert property(submod_cog_2_ptr_w_in_result == submod_cog_2_ptr_w_in_expected);
assert property(submod_cog_3_nres_in_result == submod_cog_3_nres_in_expected);
assert property(submod_cog_3_cnt_in_result == submod_cog_3_cnt_in_expected);
assert property(submod_cog_6_bus_sel_in_result == submod_cog_6_bus_sel_in_expected);
assert property(submod_cog_1_ena_in_result == submod_cog_1_ena_in_expected);
assert property(submod_cog_3_pll_in_in_result[7:0] == submod_cog_3_pll_in_in_expected);
assert property(submod_cog_3_pll_in_in_result[31:8] == 64'h0);
endmodule

//-show submod_cog_4_bus_ack_in_result -show submod_cog_4_bus_ack_in_expected -show submod_cog_5_pll_in_in_result -show submod_cog_5_pll_in_in_expected -show submod_cog_1_ptr_w_in_result -show submod_cog_1_ptr_w_in_expected -show submod_cog_3_pin_in_in_result -show submod_cog_3_pin_in_in_expected -show submod_cog_1_bus_c_in_result -show submod_cog_1_bus_c_in_expected -show submod_cog_2_clk_pll_in_result -show submod_cog_2_clk_pll_in_expected -show submod_cog_7_ptr_d_in_result -show submod_cog_7_ptr_d_in_expected -show submod_cog_3_bus_sel_in_result -show submod_cog_3_bus_sel_in_expected -show submod_cog_4_clk_cog_in_result -show submod_cog_4_clk_cog_in_expected -show submod_cog_4_nres_in_result -show submod_cog_4_nres_in_expected -show submod_cog_4_pin_in_in_result -show submod_cog_4_pin_in_in_expected -show submod_cog_2_bus_q_in_result -show submod_cog_2_bus_q_in_expected -show submod_hub_bus_s_in_result -show submod_hub_bus_s_in_expected -show submod_cog_7_bus_q_in_result -show submod_cog_7_bus_q_in_expected -show submod_cog_5_pin_in_in_result -show submod_cog_5_pin_in_in_expected -show submod_cog_3_ena_bus_in_result -show submod_cog_3_ena_bus_in_expected -show submod_cog_7_pll_in_in_result -show submod_cog_7_pll_in_in_expected -show submod_cog_5_clk_cog_in_result -show submod_cog_5_clk_cog_in_expected -show submod_cog_5_bus_ack_in_result -show submod_cog_5_bus_ack_in_expected -show submod_cog_1_nres_in_result -show submod_cog_1_nres_in_expected -show submod_cog_4_pll_in_in_result -show submod_cog_4_pll_in_in_expected -show submod_cog_2_pin_in_in_result -show submod_cog_2_pin_in_in_expected -show submod_cog_6_ptr_w_in_result -show submod_cog_6_ptr_w_in_expected -show submod_cog_3_ptr_w_in_result -show submod_cog_3_ptr_w_in_expected -show submod_cog_1_cnt_in_result -show submod_cog_1_cnt_in_expected -show cfg_result -show cfg_expected -show submod_cog_2_ena_bus_in_result -show submod_cog_2_ena_bus_in_expected -show submod_cog_5_cnt_in_result -show submod_cog_5_cnt_in_expected -show submod_cog_3_bus_ack_in_result -show submod_cog_3_bus_ack_in_expected -show submod_cog_4_bus_q_in_result -show submod_cog_4_bus_q_in_expected -show submod_cog_1_ena_bus_in_result -show submod_cog_1_ena_bus_in_expected -show submod_cog_7_ena_bus_in_result -show submod_cog_7_ena_bus_in_expected -show submod_cog_4_ptr_w_in_result -show submod_cog_4_ptr_w_in_expected -show submod_cog_4_bus_c_in_result -show submod_cog_4_bus_c_in_expected -show submod_cog_0_pin_in_in_result -show submod_cog_0_pin_in_in_expected -show submod_cog_7_pin_in_in_result -show submod_cog_7_pin_in_in_expected -show submod_cog_2_nres_in_result -show submod_cog_2_nres_in_expected -show submod_cog_1_clk_pll_in_result -show submod_cog_1_clk_pll_in_expected -show submod_cog_5_bus_c_in_result -show submod_cog_5_bus_c_in_expected -show submod_hub_bus_d_in_result -show submod_hub_bus_d_in_expected -show submod_cog_6_bus_ack_in_result -show submod_cog_6_bus_ack_in_expected -show submod_cog_6_bus_q_in_result -show submod_cog_6_bus_q_in_expected -show submod_cog_3_clk_cog_in_result -show submod_cog_3_clk_cog_in_expected -show submod_cog_1_pll_in_in_result -show submod_cog_1_pll_in_in_expected -show submod_cog_2_ena_in_result -show submod_cog_2_ena_in_expected -show submod_cog_0_ena_in_result -show submod_cog_0_ena_in_expected -show submod_cog_1_bus_sel_in_result -show submod_cog_1_bus_sel_in_expected -show submod_cog_3_clk_pll_in_result -show submod_cog_3_clk_pll_in_expected -show submod_cog_1_pin_in_in_result -show submod_cog_1_pin_in_in_expected -show pin_dir_result -show pin_dir_expected -show submod_cog_0_pll_in_in_result -show submod_cog_0_pll_in_in_expected -show submod_cog_0_ptr_w_in_result -show submod_cog_0_ptr_w_in_expected -show submod_cog_2_ptr_d_in_result -show submod_cog_2_ptr_d_in_expected -show submod_cog_5_ptr_d_in_result -show submod_cog_5_ptr_d_in_expected -show submod_cog_7_bus_sel_in_result -show submod_cog_7_bus_sel_in_expected -show submod_cog_0_bus_q_in_result -show submod_cog_0_bus_q_in_expected -show submod_cog_6_pll_in_in_result -show submod_cog_6_pll_in_in_expected -show submod_cog_3_bus_q_in_result -show submod_cog_3_bus_q_in_expected -show submod_hub_nres_in_result -show submod_hub_nres_in_expected -show submod_cog_6_pin_in_in_result -show submod_cog_6_pin_in_in_expected -show submod_cog_7_clk_pll_in_result -show submod_cog_7_clk_pll_in_expected -show submod_cog_7_cnt_in_result -show submod_cog_7_cnt_in_expected -show submod_cog_5_ena_in_result -show submod_cog_5_ena_in_expected -show submod_cog_7_ptr_w_in_result -show submod_cog_7_ptr_w_in_expected -show submod_cog_5_bus_sel_in_result -show submod_cog_5_bus_sel_in_expected -show submod_cog_7_nres_in_result -show submod_cog_7_nres_in_expected -show submod_hub_bus_e_in_result -show submod_hub_bus_e_in_expected -show submod_cog_1_bus_ack_in_result -show submod_cog_1_bus_ack_in_expected -show submod_cog_0_bus_sel_in_result -show submod_cog_0_bus_sel_in_expected -show cog_led_result -show cog_led_expected -show submod_cog_1_clk_cog_in_result -show submod_cog_1_clk_cog_in_expected -show submod_cog_7_clk_cog_in_result -show submod_cog_7_clk_cog_in_expected -show submod_cog_0_nres_in_result -show submod_cog_0_nres_in_expected -show reg_cnt_d_result -show reg_cnt_d_expected -show submod_cog_5_clk_pll_in_result -show submod_cog_5_clk_pll_in_expected -show submod_cog_5_ena_bus_in_result -show submod_cog_5_ena_bus_in_expected -show submod_cog_0_cnt_in_result -show submod_cog_0_cnt_in_expected -show submod_cog_2_cnt_in_result -show submod_cog_2_cnt_in_expected -show submod_cog_4_cnt_in_result -show submod_cog_4_cnt_in_expected -show submod_cog_6_cnt_in_result -show submod_cog_6_cnt_in_expected -show submod_hub_clk_cog_in_result -show submod_hub_clk_cog_in_expected -show reg_ena_bus_d_result -show reg_ena_bus_d_expected -show submod_cog_7_bus_ack_in_result -show submod_cog_7_bus_ack_in_expected -show submod_cog_0_ena_bus_in_result -show submod_cog_0_ena_bus_in_expected -show submod_cog_1_bus_q_in_result -show submod_cog_1_bus_q_in_expected -show submod_cog_0_clk_pll_in_result -show submod_cog_0_clk_pll_in_expected -show submod_cog_0_bus_c_in_result -show submod_cog_0_bus_c_in_expected -show submod_cog_6_clk_cog_in_result -show submod_cog_6_clk_cog_in_expected -show submod_cog_2_bus_c_in_result -show submod_cog_2_bus_c_in_expected -show submod_cog_7_ena_in_result -show submod_cog_7_ena_in_expected -show submod_cog_2_bus_ack_in_result -show submod_cog_2_bus_ack_in_expected -show submod_cog_5_nres_in_result -show submod_cog_5_nres_in_expected -show submod_cog_6_ptr_d_in_result -show submod_cog_6_ptr_d_in_expected -show submod_cog_3_ena_in_result -show submod_cog_3_ena_in_expected -show submod_cog_7_bus_c_in_result -show submod_cog_7_bus_c_in_expected -show submod_cog_1_ptr_d_in_result -show submod_cog_1_ptr_d_in_expected -show pin_out_result -show pin_out_expected -show reg_bus_sel_d_result -show reg_bus_sel_d_expected -show submod_cog_4_ptr_d_in_result -show submod_cog_4_ptr_d_in_expected -show submod_hub_bus_a_in_result -show submod_hub_bus_a_in_expected -show submod_cog_5_bus_q_in_result -show submod_cog_5_bus_q_in_expected -show submod_cog_2_pll_in_in_result -show submod_cog_2_pll_in_in_expected -show submod_hub_bus_sel_in_result -show submod_hub_bus_sel_in_expected -show submod_cog_5_ptr_w_in_result -show submod_cog_5_ptr_w_in_expected -show submod_cog_2_bus_sel_in_result -show submod_cog_2_bus_sel_in_expected -show submod_cog_6_ena_in_result -show submod_cog_6_ena_in_expected -show submod_cog_4_clk_pll_in_result -show submod_cog_4_clk_pll_in_expected -show submod_cog_3_ptr_d_in_result -show submod_cog_3_ptr_d_in_expected -show submod_cog_4_ena_bus_in_result -show submod_cog_4_ena_bus_in_expected -show submod_cog_4_ena_in_result -show submod_cog_4_ena_in_expected -show submod_cog_0_bus_ack_in_result -show submod_cog_0_bus_ack_in_expected -show submod_cog_6_nres_in_result -show submod_cog_6_nres_in_expected -show submod_cog_2_clk_cog_in_result -show submod_cog_2_clk_cog_in_expected -show submod_hub_bus_w_in_result -show submod_hub_bus_w_in_expected -show submod_hub_ena_bus_in_result -show submod_hub_ena_bus_in_expected -show submod_cog_6_clk_pll_in_result -show submod_cog_6_clk_pll_in_expected -show submod_cog_4_bus_sel_in_result -show submod_cog_4_bus_sel_in_expected -show submod_cog_0_ptr_d_in_result -show submod_cog_0_ptr_d_in_expected -show submod_cog_0_clk_cog_in_result -show submod_cog_0_clk_cog_in_expected -show submod_cog_6_ena_bus_in_result -show submod_cog_6_ena_bus_in_expected -show submod_hub_bus_r_in_result -show submod_hub_bus_r_in_expected -show submod_cog_3_bus_c_in_result -show submod_cog_3_bus_c_in_expected -show submod_cog_6_bus_c_in_result -show submod_cog_6_bus_c_in_expected -show submod_cog_2_ptr_w_in_result -show submod_cog_2_ptr_w_in_expected -show submod_cog_3_nres_in_result -show submod_cog_3_nres_in_expected -show submod_cog_3_cnt_in_result -show submod_cog_3_cnt_in_expected -show submod_cog_6_bus_sel_in_result -show submod_cog_6_bus_sel_in_expected -show submod_cog_1_ena_in_result -show submod_cog_1_ena_in_expected -show submod_cog_3_pll_in_in_result -show submod_cog_3_pll_in_in_expected 

module dig (
input [31:0] submod_cog_4_bus_d_out,
output submod_cog_4_bus_ack_in,
input submod_cog_0_bus_e_out,
input [1:0] submod_cog_2_bus_s_out,
output [7:0] submod_cog_5_pll_in_in,
output submod_cog_1_ptr_w_in,
output [31:0] submod_cog_3_pin_in_in,
output submod_cog_1_bus_c_in,
output submod_cog_2_clk_pll_in,
output [27:0] submod_cog_7_ptr_d_in,
input submod_cog_6_bus_r_out,
output submod_cog_3_bus_sel_in,
input submod_hub_bus_c_out,
input submod_cog_0_bus_w_out,
input [15:0] submod_cog_2_bus_a_out,
input submod_cog_2_pll_out_out,
input submod_cog_3_pll_out_out,
input submod_cog_4_pll_out_out,
output submod_cog_4_clk_cog_in,
input submod_cog_5_pll_out_out,
input submod_cog_6_pll_out_out,
input [31:0] submod_cog_3_bus_d_out,
input submod_cog_5_bus_r_out,
input submod_cog_7_pll_out_out,
output submod_cog_4_nres_in,
output [31:0] submod_cog_4_pin_in_in,
input [15:0] submod_cog_1_bus_a_out,
output [31:0] submod_cog_2_bus_q_in,
input clk_pll,
input [1:0] submod_cog_1_bus_s_out,
input [31:0] submod_hub_bus_q_out,
output [1:0] submod_hub_bus_s_in,
output [31:0] submod_cog_7_bus_q_in,
output [31:0] submod_cog_5_pin_in_in,
input posedge_clk_cog,
output submod_cog_3_ena_bus_in,
input [15:0] submod_cog_0_bus_a_out,
output [7:0] submod_cog_7_pll_in_in,
output submod_cog_5_clk_cog_in,
output submod_cog_5_bus_ack_in,
output submod_cog_1_nres_in,
output [7:0] submod_cog_4_pll_in_in,
input [27:0] submod_hub_ptr_d_out,
input [1:0] submod_cog_0_bus_s_out,
output [31:0] submod_cog_2_pin_in_in,
input submod_cog_4_bus_r_out,
output submod_cog_6_ptr_w_in,
output submod_cog_3_ptr_w_in,
input negedge_nres,
input [1:0] submod_cog_3_bus_s_out,
output [31:0] submod_cog_1_cnt_in,
input [31:0] submod_cog_5_bus_d_out,
output [7:0] cfg,
input submod_cog_7_bus_r_out,
output submod_cog_2_ena_bus_in,
output [31:0] submod_cog_5_cnt_in,
input submod_cog_1_bus_e_out,
output submod_cog_3_bus_ack_in,
output [31:0] submod_cog_4_bus_q_in,
output submod_cog_1_ena_bus_in,
input [31:0] submod_cog_2_bus_d_out,
input [15:0] submod_cog_3_bus_a_out,
input submod_cog_1_bus_w_out,
output submod_cog_7_ena_bus_in,
input [15:0] submod_cog_5_bus_a_out,
output submod_cog_4_ptr_w_in,
output submod_cog_4_bus_c_in,
input submod_cog_4_bus_w_out,
output [31:0] submod_cog_0_pin_in_in,
input [1:0] submod_cog_5_bus_s_out,
output [31:0] submod_cog_7_pin_in_in,
output submod_cog_2_nres_in,
output submod_cog_1_clk_pll_in,
input [31:0] submod_cog_1_bus_d_out,
input submod_cog_4_bus_e_out,
output submod_cog_5_bus_c_in,
output [31:0] submod_hub_bus_d_in,
output submod_cog_6_bus_ack_in,
output [31:0] submod_cog_6_bus_q_in,
output submod_cog_3_clk_cog_in,
output [7:0] submod_cog_1_pll_in_in,
input [31:0] submod_cog_0_bus_d_out,
output submod_cog_2_ena_in,
output submod_cog_0_ena_in,
output submod_cog_1_bus_sel_in,
output submod_cog_3_clk_pll_in,
input [31:0] submod_cog_7_bus_d_out,
output [31:0] submod_cog_1_pin_in_in,
output [31:0] pin_dir,
output [7:0] submod_cog_0_pll_in_in,
input [1:0] submod_cog_4_bus_s_out,
output submod_cog_0_ptr_w_in,
input [31:0] submod_cog_6_bus_d_out,
output [27:0] submod_cog_2_ptr_d_in,
input [15:0] submod_cog_4_bus_a_out,
output [27:0] submod_cog_5_ptr_d_in,
output submod_cog_7_bus_sel_in,
output [31:0] submod_cog_0_bus_q_in,
output [7:0] submod_cog_6_pll_in_in,
input [7:0] submod_hub_ptr_w_out,
output [31:0] submod_cog_3_bus_q_in,
output submod_hub_nres_in,
output [31:0] submod_cog_6_pin_in_in,
input submod_cog_5_bus_w_out,
input submod_cog_0_bus_r_out,
input submod_cog_1_pll_out_out,
input submod_cog_5_bus_e_out,
output submod_cog_7_clk_pll_in,
output [31:0] submod_cog_7_cnt_in,
output submod_cog_5_ena_in,
output submod_cog_7_ptr_w_in,
output submod_cog_5_bus_sel_in,
output submod_cog_7_nres_in,
output submod_hub_bus_e_in,
input [31:0] reg_cnt_q,
output submod_cog_1_bus_ack_in,
output submod_cog_0_bus_sel_in,
input submod_cog_7_bus_e_out,
input reg_ena_bus_q,
output [7:0] cog_led,
output submod_cog_1_clk_cog_in,
output submod_cog_7_clk_cog_in,
output submod_cog_0_nres_in,
input [31:0] pin_in,
output reg [31:0] reg_cnt_d,
output submod_cog_5_clk_pll_in,
input [31:0] submod_cog_0_pin_out_out,
input submod_cog_7_bus_w_out,
output submod_cog_5_ena_bus_in,
output [31:0] submod_cog_0_cnt_in,
output [31:0] submod_cog_2_cnt_in,
input [31:0] submod_cog_1_pin_dir_out,
input [31:0] submod_cog_0_pin_dir_out,
input [31:0] submod_cog_3_pin_dir_out,
output [31:0] submod_cog_4_cnt_in,
output [31:0] submod_cog_6_cnt_in,
input submod_cog_6_bus_e_out,
input [31:0] submod_cog_2_pin_dir_out,
input [31:0] submod_cog_7_pin_dir_out,
output submod_hub_clk_cog_in,
input [31:0] submod_cog_5_pin_dir_out,
input [31:0] submod_cog_4_pin_dir_out,
output reg reg_ena_bus_d,
output submod_cog_7_bus_ack_in,
input [31:0] submod_cog_6_pin_dir_out,
output submod_cog_0_ena_bus_in,
input submod_cog_6_bus_w_out,
input nres,
output [31:0] submod_cog_1_bus_q_in,
output submod_cog_0_clk_pll_in,
output submod_cog_0_bus_c_in,
input submod_cog_1_bus_r_out,
input [31:0] submod_cog_2_pin_out_out,
output submod_cog_6_clk_cog_in,
input [15:0] submod_cog_6_bus_a_out,
output submod_cog_2_bus_c_in,
output submod_cog_7_ena_in,
input [31:0] submod_cog_1_pin_out_out,
input [31:0] submod_cog_5_pin_out_out,
input [7:0] submod_hub_bus_ack_out,
output submod_cog_2_bus_ack_in,
output submod_cog_5_nres_in,
input [31:0] submod_cog_4_pin_out_out,
input [31:0] submod_cog_3_pin_out_out,
output [27:0] submod_cog_6_ptr_d_in,
input [7:0] submod_hub_cfg_out,
output submod_cog_3_ena_in,
output submod_cog_7_bus_c_in,
input [31:0] submod_cog_6_pin_out_out,
output [27:0] submod_cog_1_ptr_d_in,
input [1:0] submod_cog_6_bus_s_out,
input [31:0] submod_cog_7_pin_out_out,
output [31:0] pin_out,
output reg [7:0] reg_bus_sel_d,
output [27:0] submod_cog_4_ptr_d_in,
output [15:0] submod_hub_bus_a_in,
output [31:0] submod_cog_5_bus_q_in,
input submod_cog_2_bus_r_out,
output [7:0] submod_cog_2_pll_in_in,
output [7:0] submod_hub_bus_sel_in,
output submod_cog_5_ptr_w_in,
output submod_cog_2_bus_sel_in,
output submod_cog_6_ena_in,
output submod_cog_4_clk_pll_in,
output [27:0] submod_cog_3_ptr_d_in,
input submod_cog_3_bus_w_out,
output submod_cog_4_ena_bus_in,
output submod_cog_4_ena_in,
output submod_cog_0_bus_ack_in,
output submod_cog_6_nres_in,
input clk_cog,
input submod_cog_3_bus_e_out,
output submod_cog_2_clk_cog_in,
output submod_hub_bus_w_in,
input [7:0] reg_bus_sel_q,
output submod_hub_ena_bus_in,
input [15:0] submod_cog_7_bus_a_out,
input submod_cog_2_bus_e_out,
output submod_cog_6_clk_pll_in,
output submod_cog_4_bus_sel_in,
output [27:0] submod_cog_0_ptr_d_in,
output submod_cog_0_clk_cog_in,
output submod_cog_6_ena_bus_in,
input [1:0] submod_cog_7_bus_s_out,
input submod_cog_2_bus_w_out,
output submod_hub_bus_r_in,
output submod_cog_3_bus_c_in,
output submod_cog_6_bus_c_in,
input [7:0] submod_hub_cog_ena_out,
output submod_cog_2_ptr_w_in,
output submod_cog_3_nres_in,
output [31:0] submod_cog_3_cnt_in,
output submod_cog_6_bus_sel_in,
input submod_cog_0_pll_out_out,
output submod_cog_1_ena_in,
output [7:0] submod_cog_3_pll_in_in,
input submod_cog_3_bus_r_out
);
wire [7:0] bus_ack;
wire [7:0] cog_ena;
wire [31:0] outx[8];
wire [7:0] ptr_w;
wire [15:0] hub_bus_a;
wire [31:0] hub_bus_d;
wire hub_bus_e;
wire [27:0] ptr_d;
wire hub_bus_r;
wire [1:0] hub_bus_s;
wire hub_bus_w;
wire [31:0] dirx[8];
wire [7:0] bus_w;
wire [7:0] bus_r;
wire [31:0] bus_q;
wire [1:0] bus_s[8];
wire [7:0] pll;
wire [15:0] bus_a[8];
wire [7:0] bus_e;
wire [31:0] bus_d[8];
wire bus_c;
assign hub_bus_r = (|bus_r);
assign hub_bus_e = (|bus_e);
assign hub_bus_w = (|bus_w);
assign hub_bus_s = (bus_s[7] | (bus_s[6] | (bus_s[5] | (bus_s[4] | (bus_s[3] | (bus_s[2] | (bus_s[1] | bus_s[0])))))));
assign hub_bus_a = (bus_a[7] | (bus_a[6] | (bus_a[5] | (bus_a[4] | (bus_a[3] | (bus_a[2] | (bus_a[1] | bus_a[0])))))));
assign hub_bus_d = (bus_d[7] | (bus_d[6] | (bus_d[5] | (bus_d[4] | (bus_d[3] | (bus_d[2] | (bus_d[1] | bus_d[0])))))));
assign pin_out = (outx[7] | (outx[6] | (outx[5] | (outx[4] | (outx[3] | (outx[2] | (outx[1] | outx[0])))))));
assign pin_dir = (dirx[7] | (dirx[6] | (dirx[5] | (dirx[4] | (dirx[3] | (dirx[2] | (dirx[1] | dirx[0])))))));
assign cog_led = cog_ena;
assign submod_cog_0_bus_ack_in = bus_ack[0];
assign outx[0] = submod_cog_0_pin_out_out;
assign submod_cog_0_ptr_w_in = ptr_w[0];
assign submod_cog_0_pin_in_in = pin_in;
assign submod_cog_0_ena_bus_in = reg_ena_bus_q;
assign submod_cog_0_pll_in_in = pll;
assign submod_cog_0_ptr_d_in = ptr_d;
assign submod_cog_0_clk_pll_in = clk_pll;
assign submod_cog_0_clk_cog_in = clk_cog;
assign submod_cog_0_nres_in = nres;
assign dirx[0] = submod_cog_0_pin_dir_out;
assign submod_cog_0_bus_sel_in = reg_bus_sel_q[0];
assign submod_cog_0_ena_in = cog_ena[0];
assign pll[0] = submod_cog_0_pll_out_out;
assign bus_w[0] = submod_cog_0_bus_w_out;
assign bus_r[0] = submod_cog_0_bus_r_out;
assign submod_cog_0_cnt_in = reg_cnt_q;
assign submod_cog_0_bus_q_in = bus_q;
assign bus_s[0] = submod_cog_0_bus_s_out;
assign bus_a[0] = submod_cog_0_bus_a_out;
assign bus_e[0] = submod_cog_0_bus_e_out;
assign bus_d[0] = submod_cog_0_bus_d_out;
assign submod_cog_0_bus_c_in = bus_c;
assign submod_cog_1_bus_ack_in = bus_ack[1];
assign outx[1] = submod_cog_1_pin_out_out;
assign submod_cog_1_ptr_w_in = ptr_w[1];
assign submod_cog_1_pin_in_in = pin_in;
assign submod_cog_1_ena_bus_in = reg_ena_bus_q;
assign submod_cog_1_pll_in_in = pll;
assign submod_cog_1_ptr_d_in = ptr_d;
assign submod_cog_1_clk_pll_in = clk_pll;
assign submod_cog_1_clk_cog_in = clk_cog;
assign submod_cog_1_nres_in = nres;
assign dirx[1] = submod_cog_1_pin_dir_out;
assign submod_cog_1_bus_sel_in = reg_bus_sel_q[1];
assign submod_cog_1_ena_in = cog_ena[1];
assign pll[1] = submod_cog_1_pll_out_out;
assign bus_w[1] = submod_cog_1_bus_w_out;
assign bus_r[1] = submod_cog_1_bus_r_out;
assign submod_cog_1_cnt_in = reg_cnt_q;
assign submod_cog_1_bus_q_in = bus_q;
assign bus_s[1] = submod_cog_1_bus_s_out;
assign bus_a[1] = submod_cog_1_bus_a_out;
assign bus_e[1] = submod_cog_1_bus_e_out;
assign bus_d[1] = submod_cog_1_bus_d_out;
assign submod_cog_1_bus_c_in = bus_c;
assign submod_cog_2_bus_ack_in = bus_ack[2];
assign outx[2] = submod_cog_2_pin_out_out;
assign submod_cog_2_ptr_w_in = ptr_w[2];
assign submod_cog_2_pin_in_in = pin_in;
assign submod_cog_2_ena_bus_in = reg_ena_bus_q;
assign submod_cog_2_pll_in_in = pll;
assign submod_cog_2_ptr_d_in = ptr_d;
assign submod_cog_2_clk_pll_in = clk_pll;
assign submod_cog_2_clk_cog_in = clk_cog;
assign submod_cog_2_nres_in = nres;
assign dirx[2] = submod_cog_2_pin_dir_out;
assign submod_cog_2_bus_sel_in = reg_bus_sel_q[2];
assign submod_cog_2_ena_in = cog_ena[2];
assign pll[2] = submod_cog_2_pll_out_out;
assign bus_w[2] = submod_cog_2_bus_w_out;
assign bus_r[2] = submod_cog_2_bus_r_out;
assign submod_cog_2_cnt_in = reg_cnt_q;
assign submod_cog_2_bus_q_in = bus_q;
assign bus_s[2] = submod_cog_2_bus_s_out;
assign bus_a[2] = submod_cog_2_bus_a_out;
assign bus_e[2] = submod_cog_2_bus_e_out;
assign bus_d[2] = submod_cog_2_bus_d_out;
assign submod_cog_2_bus_c_in = bus_c;
assign submod_cog_3_bus_ack_in = bus_ack[3];
assign outx[3] = submod_cog_3_pin_out_out;
assign submod_cog_3_ptr_w_in = ptr_w[3];
assign submod_cog_3_pin_in_in = pin_in;
assign submod_cog_3_ena_bus_in = reg_ena_bus_q;
assign submod_cog_3_pll_in_in = pll;
assign submod_cog_3_ptr_d_in = ptr_d;
assign submod_cog_3_clk_pll_in = clk_pll;
assign submod_cog_3_clk_cog_in = clk_cog;
assign submod_cog_3_nres_in = nres;
assign dirx[3] = submod_cog_3_pin_dir_out;
assign submod_cog_3_bus_sel_in = reg_bus_sel_q[3];
assign submod_cog_3_ena_in = cog_ena[3];
assign pll[3] = submod_cog_3_pll_out_out;
assign bus_w[3] = submod_cog_3_bus_w_out;
assign bus_r[3] = submod_cog_3_bus_r_out;
assign submod_cog_3_cnt_in = reg_cnt_q;
assign submod_cog_3_bus_q_in = bus_q;
assign bus_s[3] = submod_cog_3_bus_s_out;
assign bus_a[3] = submod_cog_3_bus_a_out;
assign bus_e[3] = submod_cog_3_bus_e_out;
assign bus_d[3] = submod_cog_3_bus_d_out;
assign submod_cog_3_bus_c_in = bus_c;
assign submod_cog_4_bus_ack_in = bus_ack[4];
assign outx[4] = submod_cog_4_pin_out_out;
assign submod_cog_4_ptr_w_in = ptr_w[4];
assign submod_cog_4_pin_in_in = pin_in;
assign submod_cog_4_ena_bus_in = reg_ena_bus_q;
assign submod_cog_4_pll_in_in = pll;
assign submod_cog_4_ptr_d_in = ptr_d;
assign submod_cog_4_clk_pll_in = clk_pll;
assign submod_cog_4_clk_cog_in = clk_cog;
assign submod_cog_4_nres_in = nres;
assign dirx[4] = submod_cog_4_pin_dir_out;
assign submod_cog_4_bus_sel_in = reg_bus_sel_q[4];
assign submod_cog_4_ena_in = cog_ena[4];
assign pll[4] = submod_cog_4_pll_out_out;
assign bus_w[4] = submod_cog_4_bus_w_out;
assign bus_r[4] = submod_cog_4_bus_r_out;
assign submod_cog_4_cnt_in = reg_cnt_q;
assign submod_cog_4_bus_q_in = bus_q;
assign bus_s[4] = submod_cog_4_bus_s_out;
assign bus_a[4] = submod_cog_4_bus_a_out;
assign bus_e[4] = submod_cog_4_bus_e_out;
assign bus_d[4] = submod_cog_4_bus_d_out;
assign submod_cog_4_bus_c_in = bus_c;
assign submod_cog_5_bus_ack_in = bus_ack[5];
assign outx[5] = submod_cog_5_pin_out_out;
assign submod_cog_5_ptr_w_in = ptr_w[5];
assign submod_cog_5_pin_in_in = pin_in;
assign submod_cog_5_ena_bus_in = reg_ena_bus_q;
assign submod_cog_5_pll_in_in = pll;
assign submod_cog_5_ptr_d_in = ptr_d;
assign submod_cog_5_clk_pll_in = clk_pll;
assign submod_cog_5_clk_cog_in = clk_cog;
assign submod_cog_5_nres_in = nres;
assign dirx[5] = submod_cog_5_pin_dir_out;
assign submod_cog_5_bus_sel_in = reg_bus_sel_q[5];
assign submod_cog_5_ena_in = cog_ena[5];
assign pll[5] = submod_cog_5_pll_out_out;
assign bus_w[5] = submod_cog_5_bus_w_out;
assign bus_r[5] = submod_cog_5_bus_r_out;
assign submod_cog_5_cnt_in = reg_cnt_q;
assign submod_cog_5_bus_q_in = bus_q;
assign bus_s[5] = submod_cog_5_bus_s_out;
assign bus_a[5] = submod_cog_5_bus_a_out;
assign bus_e[5] = submod_cog_5_bus_e_out;
assign bus_d[5] = submod_cog_5_bus_d_out;
assign submod_cog_5_bus_c_in = bus_c;
assign submod_cog_6_bus_ack_in = bus_ack[6];
assign outx[6] = submod_cog_6_pin_out_out;
assign submod_cog_6_ptr_w_in = ptr_w[6];
assign submod_cog_6_pin_in_in = pin_in;
assign submod_cog_6_ena_bus_in = reg_ena_bus_q;
assign submod_cog_6_pll_in_in = pll;
assign submod_cog_6_ptr_d_in = ptr_d;
assign submod_cog_6_clk_pll_in = clk_pll;
assign submod_cog_6_clk_cog_in = clk_cog;
assign submod_cog_6_nres_in = nres;
assign dirx[6] = submod_cog_6_pin_dir_out;
assign submod_cog_6_bus_sel_in = reg_bus_sel_q[6];
assign submod_cog_6_ena_in = cog_ena[6];
assign pll[6] = submod_cog_6_pll_out_out;
assign bus_w[6] = submod_cog_6_bus_w_out;
assign bus_r[6] = submod_cog_6_bus_r_out;
assign submod_cog_6_cnt_in = reg_cnt_q;
assign submod_cog_6_bus_q_in = bus_q;
assign bus_s[6] = submod_cog_6_bus_s_out;
assign bus_a[6] = submod_cog_6_bus_a_out;
assign bus_e[6] = submod_cog_6_bus_e_out;
assign bus_d[6] = submod_cog_6_bus_d_out;
assign submod_cog_6_bus_c_in = bus_c;
assign submod_cog_7_bus_ack_in = bus_ack[7];
assign outx[7] = submod_cog_7_pin_out_out;
assign submod_cog_7_ptr_w_in = ptr_w[7];
assign submod_cog_7_pin_in_in = pin_in;
assign submod_cog_7_ena_bus_in = reg_ena_bus_q;
assign submod_cog_7_pll_in_in = pll;
assign submod_cog_7_ptr_d_in = ptr_d;
assign submod_cog_7_clk_pll_in = clk_pll;
assign submod_cog_7_clk_cog_in = clk_cog;
assign submod_cog_7_nres_in = nres;
assign dirx[7] = submod_cog_7_pin_dir_out;
assign submod_cog_7_bus_sel_in = reg_bus_sel_q[7];
assign submod_cog_7_ena_in = cog_ena[7];
assign pll[7] = submod_cog_7_pll_out_out;
assign bus_w[7] = submod_cog_7_bus_w_out;
assign bus_r[7] = submod_cog_7_bus_r_out;
assign submod_cog_7_cnt_in = reg_cnt_q;
assign submod_cog_7_bus_q_in = bus_q;
assign bus_s[7] = submod_cog_7_bus_s_out;
assign bus_a[7] = submod_cog_7_bus_a_out;
assign bus_e[7] = submod_cog_7_bus_e_out;
assign bus_d[7] = submod_cog_7_bus_d_out;
assign submod_cog_7_bus_c_in = bus_c;
assign bus_ack = submod_hub_bus_ack_out;
assign submod_hub_nres_in = nres;
assign ptr_w = submod_hub_ptr_w_out;
assign submod_hub_bus_sel_in = reg_bus_sel_q;
assign submod_hub_ena_bus_in = reg_ena_bus_q;
assign cog_ena = submod_hub_cog_ena_out;
assign submod_hub_bus_w_in = hub_bus_w;
assign cfg = submod_hub_cfg_out;
assign submod_hub_bus_r_in = hub_bus_r;
assign bus_q = submod_hub_bus_q_out;
assign submod_hub_bus_s_in = hub_bus_s;
assign ptr_d = submod_hub_ptr_d_out;
assign submod_hub_bus_a_in = hub_bus_a;
assign submod_hub_clk_cog_in = clk_cog;
assign submod_hub_bus_e_in = hub_bus_e;
assign submod_hub_bus_d_in = hub_bus_d;
assign bus_c = submod_hub_bus_c_out;
always @(*) begin
    reg_cnt_d <= reg_cnt_q;
    reg_bus_sel_d <= reg_bus_sel_q;
    reg_ena_bus_d <= reg_ena_bus_q;
    if (posedge_clk_cog) begin
        if (nres) begin
            reg_cnt_d <= (reg_cnt_q + 1'b1);
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_ena_bus_d <= 1'b0;
        end else begin
            reg_ena_bus_d <= (!reg_ena_bus_q);
        end
    end
    if ((posedge_clk_cog || negedge_nres)) begin
        if ((!nres)) begin
            reg_bus_sel_d <= 8'h0;
        end else begin
            if (reg_ena_bus_q) begin
                reg_bus_sel_d <= {reg_bus_sel_q[6:0], (~|reg_bus_sel_q[6:0])};
            end
        end
    end
end
endmodule

