nasm.name = nasm ${QMAKE_FILE_IN}
nasm.input = ASM_FILES
nasm.variable_out = OBJECTS
nasm.commands = nasm -f elf64 ${QMAKE_FILE_IN} -o ${QMAKE_FILE_OUT} -i "$$PWD" -w+error=all
nasm.output = ${QMAKE_VAR_OBJECTS_DIR}${QMAKE_FILE_IN_BASE}$${first(QMAKE_EXT_OBJ)}
nasm.CONFIG += target_predeps
QMAKE_EXTRA_COMPILERS  += nasm

SOURCES += propeller-asm/propellerasm.cpp
HEADERS += propeller-asm/propellerasm.h \
    $$PWD//remainingpropellerasm.h \
    $$PWD/propellerasmported.h \
    $$PWD/propellerasmregsets.gen.h \
    $$PWD/propellerasmmemorymap.h \
    $$PWD/asm-callstubs.gen.h


ASM_FILES += propeller-asm/asm-main.asm
OTHER_FILES += propeller-asm/asm-memorymap.asm \
    propeller-asm/asm-cogclk-zflagmacros.gen.asm \
    propeller-asm/asm-hubclk-enabus.gen.asm \
    propeller-asm/asm-cogclk-stateother.gen.asm \
    propeller-asm/asm-cogclk-state4.gen.asm \
    propeller-asm/asm-tables.gen.asm \
    propeller-asm/asm-callstubs.gen.asm \
    propeller-asm/asm-patches.gen.asm \
    propeller-asm/asm-other.gen.asm \
    propeller-asm/asm-regs.gen.asm \
    propeller-asm/asm-cogpreeval.asm \
    propeller-asm/asm-manual-tables.asm \
    propeller-asm/asm-cogpinout.asm \
    propeller-asm/asm-hub.asm \
    propeller-asm/asm-cogclk-peripherals.asm \
    propeller-asm/asm-debug.asm
