#ifndef MANUALPORTEDPROPELLER_H
#define MANUALPORTEDPROPELLER_H

#include <QtDebug>
#include <QDataStream>

struct clocks_dig {
    clocks_dig() {
        for (int i=0; i<8; ++i)  {
            posedge_vclk[i] = false;
            posedge_snc1[i] = false;
            negedge_ena[i] = false;
        }
    }

    bool posedge_vclk[8];
    bool posedge_snc1[8];
    bool negedge_ena[8];
};

/*
struct module_cloned_hub_mem {
    module_cloned_hub_mem():reg_q(0U) {

    }

    enum {TotalHubMemoryWords=1024*16};
    quint32 reg_q;
    quint32 memory[TotalHubMemoryWords];

    void evaluate0(const bool posedge_clk_cog, const bool ena_bus, const bool w, const quint32 wb, const quint32 a, const quint32 d, quint32& q) {
        q = reg_q;

        if (posedge_clk_cog && ena_bus) {
            const quint32 amasked = a & 0x3FFFU;
            if (w && (amasked & 0x2000U) == 0) {
                quint32 newMask = 0U;
                if ((wb & 1U) != 0U)
                    newMask |= 0xFFU;
                if ((wb & 2U) != 0U)
                    newMask |= 0xFF00U;
                if ((wb & 4U) != 0U)
                    newMask |= 0xFF0000U;
                if ((wb & 8U) != 0U)
                    newMask |= 0xFF000000U;
                memory[amasked] = (d&newMask) | (memory[amasked]&(~newMask));
                //qDebug()<<"WriteMem"<<"0x"+QString::number(a,16).rightJustified(4,'0')<<"0x"+QString::number(memory[a],16).rightJustified(8,'0');
            }
            reg_q = memory[amasked];
        }
    }

    void serialize(QDataStream& stream) const {
        stream << reg_q;
        for (int i=0; i<TotalHubMemoryWords; ++i)
            stream << memory[i];
    }

    void deserialize(QDataStream& stream) {
        stream >> reg_q;
        for (int i=0; i<TotalHubMemoryWords; ++i)
            stream >> memory[i];
    }
};
*/
#endif // MANUALPORTEDPROPELLER_H
